package graphics2;

/**
 * GestionTest : Lance l'interface graphique du logiciel
 *
 * @author maria ladoue
 * @version 0.2, 28/08/02
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;


import graphics2.panel.client.*;
import graphics2.panel.control.*;
import graphics2.panel.experiment.*;
import graphics2.panel.monitor.*;
//import graphics2.listener.MyRefreshListener;
import graphics2.listener.TrafficGeneratorActionListener;
import graphics2.listener.*;
import utils.*;
import utils.definitions.*;


/**
 * @author dsagnol
 * @date Aug 19, 2003
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class GestionTest extends JFrame {

    // Le manager
    protected GestionTestTabbedPane gestionTestTabbedPane;
    protected Action conftestAction, managerAction, analyserAction;
  	// Liste des ongletscon
  	protected ControlPanel controlPanel;
    protected ClientPanel clientPanel;
    protected ExperimentPanel experimentPanel;
    protected MonitorPanel monitorPanel;
    
	protected TrafficGeneratorActionListener tgal;

    protected Container contentPane;
    protected JMenu menuFile, menuRun, menuControl, menuHelp;
    public JMenuItem menuItemQuitter, menuItemChargerConf, menuItemEnregistrerConf, menuItemView, menuItemScenario,menuItemStatisticFile, menuItemTrafficGeneration, menuItemTestFile;
//    public JMenuItem menuItemRefresh;
    protected JToolBar toolBar = null;
    protected JMenuBar menuBar = new JMenuBar();
    protected JButton conftestButton = null,  startGeneration = null, stopTestButton = null , analyserButton = null;// createScenario = null, resetButton = null;
    //Create a file chooser
    final JFileChooser fc = new JFileChooser();
    protected String oldConfigFileName = "";  // used by refresh option

	public static int DEFAULT_WIDTH = 850;
	public static int DEFAULT_HEIGTH = 750;
    public static Dimension DEFAULT_DIMENSION = new Dimension(DEFAULT_WIDTH, DEFAULT_HEIGTH);

	protected boolean visible = true;
	
    /**
     * Construction de l'interface
     */
    public GestionTest() {
    	this(true);
    }
    
     /**
     * Construction de l'interface avec un port RMI
     */
    public GestionTest( boolean  visible ) {
    	
    	this.visible = visible;
    	tgal = new graphics2.listener.TrafficGeneratorActionListener(this);
		
		buildWindow();
		addToolBarButtons(toolBar);
		addMenuBar();

        this.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) { System.exit(0);}
        });
  
  		enableEvents(WriterEvent.WRITER_EVENT);	// ajout du 10/02/03
  
  		if(visible) {
			this.setTitle("Allegro Software");
		   //this.setSize(1050, 720);  	//this.setSize(700, 480);
		   this.setSize(DEFAULT_DIMENSION);
		   this.setVisible(true); 
	       startAccessMenu(); 
  		}       
    }

  protected void buildWindow() {
		toolBar = new JToolBar();
		
		contentPane = this.getContentPane();

		contentPane.setLayout( new BorderLayout() );
		contentPane.add( toolBar, BorderLayout.NORTH);
   }


/**
 * Method createActionComponents.
 * @param toolBar
 */
   protected void addToolBarButtons(JToolBar toolBar) {
   	
       // premier ToolButton
       gestionTestTabbedPane = new GestionTestTabbedPane(this);
       
       conftestAction = new AbstractAction( "conf test",  ImageList.confTestIcon) {
       	
            public void actionPerformed(ActionEvent e) {           
                contentPane.add( gestionTestTabbedPane, BorderLayout.CENTER );
                validate();
            }};
 
        conftestButton = toolBar.add(conftestAction);
		conftestButton.setHorizontalTextPosition(JButton.CENTER);
		conftestButton.setVerticalTextPosition(JButton.BOTTOM);
		conftestButton.setToolTipText("To go in Configuration Test Mode");

		toolBar.add(Box.createRigidArea( new Dimension(5,0)));

			//	deuxieme ToolButton
//		createScenario = new JButton(ImageList.makeScenarioIcon);
		//createScenario.addActionListener( tgal);
//		createScenario.setHorizontalTextPosition(JButton.CENTER);
//		createScenario.setVerticalTextPosition(JButton.BOTTOM);
//		createScenario.setToolTipText("To create scenarii files");
//		toolBar.add(createScenario);
		
		 toolBar.add(Box.createRigidArea( new Dimension(5,0)));

		// deuxieme ToolButton
		startGeneration = new JButton(ImageList.execIcon);
		startGeneration.addActionListener( tgal);
		startGeneration.setHorizontalTextPosition(JButton.CENTER);
		startGeneration.setVerticalTextPosition(JButton.BOTTOM);
		startGeneration.setToolTipText("To start traffic generation");
		toolBar.add(startGeneration);
		
		toolBar.add(Box.createRigidArea( new Dimension(5,0)));
		
		//	troisieme ToolButton
		stopTestButton = new JButton(ImageList.stopIcon);
		//stopTestButton.addActionListener();
		stopTestButton.setHorizontalTextPosition(JButton.CENTER);
		stopTestButton.setVerticalTextPosition(JButton.BOTTOM);
		stopTestButton.setToolTipText("To stop traffic generation");
		toolBar.add(stopTestButton);
		stopTestButton.setEnabled(false); //TODO TJ: A implenter...
		
		toolBar.add(Box.createRigidArea( new Dimension(5,0)));
		
		//	quatrieme ToolButton
//		resetButton = new JButton(ImageList.resetIcon);
//		resetButton.addActionListener(	new ActionListener() {
//			public void actionPerformed(ActionEvent e) {	
//				GestionTest.this.reset();
//			}
//		}
//		);
//		resetButton.setHorizontalTextPosition(JButton.CENTER);
//		resetButton.setVerticalTextPosition(JButton.BOTTOM);
//		resetButton.setToolTipText("To reset interface parameters");
//		toolBar.add(resetButton);
		
		toolBar.add(Box.createRigidArea( new Dimension(5,0)));
		
//     	managerFrame = new ManagerFrame(this,"Manager");
//		managerAction = new AbstractAction("manager",  ImageList.openIcon) {
//			
//		 public void actionPerformed(ActionEvent e) {
//	        	managerFrame.setVisible(true);
//               	validate();
//            }};
// 
//	    managerButton = toolBar.add(managerAction);
//		managerButton.setHorizontalTextPosition(JButton.CENTER);
//		managerButton.setVerticalTextPosition(JButton.BOTTOM);
//		managerButton.setToolTipText("To go in Manager Mode");


	// Unused button for the moment !
	analyserAction = new AbstractAction("analyser",  ImageList.saveIcon) {
	    public void actionPerformed(ActionEvent e) {
		//TODO
        }};

	analyserButton = toolBar.add(analyserAction);
	analyserButton.setHorizontalTextPosition(JButton.CENTER);
	analyserButton.setVerticalTextPosition(JButton.BOTTOM);
	analyserButton.setToolTipText("To go in Analyser Mode");
	analyserButton.setEnabled(false);
	
    }


	/**
	 * To create the menu bar
	 */
    protected void addMenuBar(){

	this.setJMenuBar(menuBar);
	
	// Premier menu
	menuFile = new JMenu("File");
	menuFile.setMnemonic(KeyEvent.VK_A);
	menuBar.add(menuFile);

	//Setting the mnemonic when constructing a menu item: quand on est dans le menu File et qu'on presse la touche L, on a directement cet Item
	menuItemChargerConf = new JMenuItem("Load configuration...",  ImageList.openIcon);
	menuItemChargerConf.setMnemonic(KeyEvent.VK_L);
	//Setting the accelerator: permet d'associer directement quitter a ALT+L
	menuItemChargerConf.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_L, ActionEvent.ALT_MASK));
	menuItemChargerConf.addActionListener( new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			loadXMLFile(true);
		}
	});
	menuFile.add(menuItemChargerConf);

	//Setting the mnemonic when constructing a menu item: quand on est dans le menu File et qu'on presse la touche L, on a directement cet Item
	menuItemEnregistrerConf = new JMenuItem("Save configuration as...",  ImageList.saveIcon);
	menuItemEnregistrerConf .setMnemonic(KeyEvent.VK_S);
	//Setting the accelerator: permet d'associer directement quitter a ALT+L
	menuItemEnregistrerConf.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, ActionEvent.ALT_MASK));
	menuItemEnregistrerConf.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			saveXMLFile(true);
		}
	});
	menuFile.add(menuItemEnregistrerConf);
	
	menuFile.add(new JSeparator());

	JMenuItem menuItemLoadHost = new JMenuItem("Load hosts information...",  ImageList.openIcon);
	//Setting the accelerator: permet d'associer directement quitter a ALT+L
	menuItemLoadHost.addActionListener( new ActionListener() {
		public void actionPerformed(ActionEvent e){
			loadXMLFile(false);
		}
	});
	menuFile.add(menuItemLoadHost);

	JMenuItem menuItemSaveHost = new JMenuItem("Save hosts information...",  ImageList.openIcon);
	//Setting the accelerator: permet d'associer directement quitter a ALT+L
	menuItemSaveHost.addActionListener( new ActionListener() {
		public void actionPerformed(ActionEvent e){
			saveXMLFile(false);
		}
	});
	menuFile.add(menuItemSaveHost);
	
	//menuItemRefresh = new JMenuItem("Refresh",  ImageList.resetIcon);
	//menuItemRefresh.addActionListener( new MyRefreshListener(this, oldConfigFileName) ); 
	//menuFile.add(menuItemRefresh);
	
	menuFile.add(new JSeparator());
	
	menuItemView = new JMenuItem("View configuration file...",  ImageList.viewIcon);
	//menuItemView.setMnemonic(KeyEvent.VK_S);
	//Setting the accelerator: permet d'associer directement quitter a ALT+L
	//menuItemView.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, ActionEvent.ALT_MASK));
	menuItemView.addActionListener( new ConfigurationFileViewer(this));
	menuFile.add(menuItemView);

	menuFile.add(new JSeparator());

	//Setting the mnemonic when constructing a menu item: quand on est dans le menu File et qu'on presse la touche Q, on a directement cet Item
	menuItemQuitter = new JMenuItem("Quit",KeyEvent.VK_Q);
       //Setting the accelerator: permet d'associer directement quitter a CTRL+Z 
	menuItemQuitter.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Z, ActionEvent.CTRL_MASK));
	menuItemQuitter.addActionListener( new MyDialogBox(this) );
	menuFile.add(menuItemQuitter);


	// Deuxieme menu
	menuRun = new JMenu("Run");
	menuBar.add(menuRun);
	menuItemScenario = new JMenuItem("Scenario files generator");
	menuItemScenario.addActionListener( new ScenariosGeneratorActionListener(this, false));
	menuRun.add(menuItemScenario);
	menuItemStatisticFile = new JMenuItem("Statistics files generator");
	menuItemStatisticFile.addActionListener( new ScenariosGeneratorActionListener(this, true) );
	menuRun.add(menuItemStatisticFile);
	menuRun.add(new JSeparator());
	menuItemTrafficGeneration = new JMenuItem("Traffic generator", ImageList.execIcon);
	menuItemTrafficGeneration.addActionListener( tgal  );
	menuRun.add( menuItemTrafficGeneration );

	// Troisieme menu
	menuControl = new JMenu("Control");
	menuBar.add(menuControl);
	menuItemTestFile = new JMenuItem("Test a Scenario file");
	menuItemTestFile.addActionListener( new TestScenarioFileActionListener(this) );
	menuControl.add(menuItemTestFile);
	
	// Quatrieme menu
    menuHelp = new JMenu("Help");
	menuBar.add(menuHelp);

    } // end afficherMenus
    
 
protected  void startAccessMenu() {
		menuFile.setEnabled(true);
		menuRun.setEnabled(true);
		menuHelp.setEnabled(true);
	
		
		menuItemQuitter.setEnabled(true);
		menuItemChargerConf.setEnabled(true);
		menuItemEnregistrerConf.setEnabled(true);
		
		menuItemScenario.setEnabled(true);
	
	}

 protected void loadMenu() {
 		menuFile.setEnabled(true);
		menuRun.setEnabled(true);
		menuHelp.setEnabled(true);
		
		
		menuItemQuitter.setEnabled(true);
		menuItemChargerConf.setEnabled(true);
		menuItemEnregistrerConf.setEnabled(true);
 }

protected	void runAccessMenu() {	
		menuFile.setEnabled(true);
		menuRun.setEnabled(true);
		menuHelp.setEnabled(true);
	
	
		menuItemQuitter.setEnabled(true);
		menuItemChargerConf.setEnabled(false);
		menuItemEnregistrerConf.setEnabled(false);
		
		menuItemScenario.setEnabled(true);
		menuItemStatisticFile.setEnabled(true);
    }


    public Container getGestionTestPanel() { return contentPane;   }

    public JToolBar getGestionTestToolBar() {	return toolBar;    }

  
    
    // To get Tabbed Pane
    public ClientPanel getClientPanel() { return clientPanel;	 }
	public ControlPanel getControlPanel() { return controlPanel; }
    public ExperimentPanel getExperimentPanel() { return experimentPanel;  }
    public MonitorPanel getMonitorPanel() {return monitorPanel;}
    

/**
 * Method freezeAll. To freeze/unfreeze all the graphic interface
 * @param b
 */
public void freezeAll(boolean b) {
	controlPanel.freezeInfo(b);
	clientPanel.freezeInfo(b);
	experimentPanel.freezeInfo(b);
	monitorPanel.freezeInfo(b);
}

public void reset() {
	controlPanel.reset();
	clientPanel.reset();
	experimentPanel.reset();
	monitorPanel.reset();
}

	/**
	 * Method loadXMLFile. Load an XML file configuration file
	 * @param isconffile if true, load a scenario configuration file
	 * else load a host information file.
	 */
	public void loadXMLFile(boolean isconffile) {
		fc.addChoosableFileFilter(new ConfigurationFileFilter());
		int returnVal = fc.showOpenDialog(GestionTest.this);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			File file = fc.getSelectedFile();
			try {
				if (file != null) {
					// Load the xml file.
					if (isconffile) {
						// Change the Title of the window...
						setTitle("Allegro Software - "+file.getAbsolutePath());

						// Load the xml file.
						clientPanel.loadScenarioFile(file.getAbsolutePath());
					}
					else // load host information file
						experimentPanel.openFile(file.getAbsolutePath());
				}
			 }
			catch(SecurityException se) {
				JOptionPane.showMessageDialog(GestionTest.this,"Permission problem","View configuration error",JOptionPane.ERROR_MESSAGE);
			}
		}
	}

	public void saveXMLFile(boolean isconffile) {
		fc.addChoosableFileFilter(new ConfigurationFileFilter());
		fc.setDialogType( JFileChooser.SAVE_DIALOG);
		int returnVal = fc.showSaveDialog(GestionTest.this);

		if (returnVal == JFileChooser.APPROVE_OPTION) {
			try {
				boolean canbeoverwritten=true;
				//  TODO: Before testing it, should happend
				if (fc.getSelectedFile().canRead() ) {
						// File already exist... do we overwrite it ? 
					if ( JOptionPane.showConfirmDialog(GestionTest.this,"This file already exists. Should we overwrite it ?","File already exists",JOptionPane.YES_NO_OPTION) ==1) {
						canbeoverwritten=false;
					}
				}
				if (canbeoverwritten) {
					String fileName = fc.getSelectedFile().getAbsolutePath();
						// Change extension to have .xml
					if (!fileName.endsWith(".xml")) {
							fileName +=".xml";
					}
					if (isconffile) {
						clientPanel.saveScenarioFile(fileName);						
							// Change the Title of the window...
						setTitle("Allegro Software - "+fileName);
					}
					else // save a host information file
						experimentPanel.saveFile(fileName);
				}
			 }
			catch(SecurityException se) {
				JOptionPane.showMessageDialog(GestionTest.this,"Permission problem","View configuration error",JOptionPane.ERROR_MESSAGE);
			}
		}
	}

protected class ArreterQuitterAction implements ActionListener{
	public void actionPerformed(ActionEvent e){
	    System.exit(0);
	}
    }// fin class ArreterQuitterAction
    
	
  protected class ConfigurationFileViewer implements ActionListener {

	protected GestionTest gestionTest;
	// Constructeur	
	public ConfigurationFileViewer(GestionTest gestionTest) {
	    this.gestionTest = gestionTest;
	}
	
	public void actionPerformed(ActionEvent e) {
  	
           fc.addChoosableFileFilter(new ConfigurationFileFilter());
           int returnVal = fc.showOpenDialog(gestionTest);

		  if (returnVal == JFileChooser.APPROVE_OPTION) {
                    File file = fc.getSelectedFile();
		    try {
			if (file != null) {
			String fileMessage = "";
			fileMessage = MyNumberFormat.configurationFileToString(file);
			JOptionPane.showConfirmDialog(null,  fileMessage, "Configuration file: " + file.getName(), JOptionPane.YES_NO_OPTION);
			
			}
		    }
		    catch(FileNotFoundException fnfe) {
			JOptionPane.showMessageDialog(GestionTest.this,"This file does not exist","View configuration error",JOptionPane.ERROR_MESSAGE);
		    }
		    catch(SecurityException se) {
			JOptionPane.showMessageDialog(GestionTest.this,"Permission problem","View configuration error",JOptionPane.ERROR_MESSAGE);
		    }
		    catch(IOException ioe) {
			JOptionPane.showMessageDialog(GestionTest.this,"This is not a directory!","View configuration error",JOptionPane.ERROR_MESSAGE);
		    }                     
		  } 
	}
    }// fin de ConfigurationFileViewer
    
    protected class MyDialogBox implements ActionListener {

	protected GestionTest gestionTest;
	// Constructeur	
	public MyDialogBox(GestionTest gestionTest) {
	    this.gestionTest = gestionTest;
	}
	
	public void actionPerformed(ActionEvent e) {
	    int n = JOptionPane.showConfirmDialog(gestionTest,"Voulez-vous quitter?","Allegro",JOptionPane.YES_NO_OPTION);
	    if (n == JOptionPane.YES_OPTION) { System.exit(0);}
	    else if (n == JOptionPane.NO_OPTION) { System.out.println("Je ne sais pas ce que je veux"); }
	}
    }// fin de MyDialogBox
    

 
    /**
	 * On definit ici les differents onglets de l'ecran principal
	 * @author mladoue
	 * @version 0.1, Aug 12, 2003
	 */
	protected class GestionTestTabbedPane extends JTabbedPane {

  	  	protected GestionTest gestionTest;
    	protected Container contentPane;

	public GestionTestTabbedPane( GestionTest gestionTest ) {
	    super();
	    this.gestionTest = gestionTest;
    
	    // Creation de l'onglet client features
	    clientPanel = new ClientPanel( gestionTest );
	    this.addTab("Client features",  ImageList.clientFeaturesIcon,clientPanel, "To specify traffic characteristics: type, channel's number");
		this.setSelectedIndex(0);  // par defaut
	    
	    // Creation de l'onglet Experiment Configuration
	    experimentPanel = new ExperimentPanel( gestionTest );
	    this.addTab("Experiment Configuration",  ImageList.experimentIcon, experimentPanel , "To specify client's number,weight");
	    
	      // Creation de l'onglet Control Configuration
	     controlPanel = new ControlPanel( gestionTest );
	     this.addTab("Control Panel",  ImageList.controlIcon, controlPanel, "To specify control parameters");  
	     
	     // Creation de l'onglet Monitor
	     monitorPanel = new MonitorPanel(gestionTest);
	     this.addTab("Monitor Experimentation", ImageList.controlIcon, monitorPanel, "Start a trafic generation");
	     this.addChangeListener(new TheChangeListener());
	     
	   } // end stateChanged      
	   
	   	// Update the ExperimentalPanel with tree informations find in ClientPanel.
		class TheChangeListener implements javax.swing.event.ChangeListener  {
			public void stateChanged( javax.swing.event.ChangeEvent event )  {
				JTabbedPane sourceTab = (JTabbedPane) event.getSource();
				if (sourceTab.getSelectedIndex()==1) { // Experimental Panel selected
					//experimentPanel.getScenariiListPanel().fxtpExperiment.clear();
					Object[] childs = clientPanel.getTreeElements();
					experimentPanel.getMachinesPanel(false).getDescriptionPanel().updateScenarioList(childs);
						// getScenariiListPanel().fxtpExperiment.setTreeImage(childs);
				}
			}
		}
	} // fin de GestionTestTabbedPane
    
    
    
    /**
     * Methode main destine a tester la methode
     */

    public static void main(String[] args) throws UnsupportedLookAndFeelException {
	//try {
	//   UIManager.setLookAndFeel(new MetalLookAndFeel());
	//"javax.swing.plaf.metal.MetalLookAndFeel"); 
	//UIManager.getCrossPlatformLookAndFeelClassName());
	//    	} catch (Exception e) { }
	
	UIManager.setLookAndFeel( new com.incors.plaf.kunststoff.KunststoffLookAndFeel() );
	GestionTest gt = new GestionTest();
	
    }
}
