package graphics2.listener;

import java.awt.event.*;
import java.net.*;

import utils.MessageManager;

import graphics2.panel.experiment.DescriptionPanel;

/**
 * This listener is used in ServerDesciptionPanel and ClientDescriptionPanel
 * @author mladoue
 * @version 0.1, Jun 20, 2003
 */

public class MyCheckBoxListener implements ItemListener {
		
		protected DescriptionPanel dp;
	
	
	   public MyCheckBoxListener(DescriptionPanel dp) {
			this.dp = dp;
	   }

	   public void itemStateChanged( ItemEvent e ) {

		Object source = e.getItemSelectable();
			   
		 if ( source == dp.ipv6) {
			 if (e.getStateChange() == ItemEvent.SELECTED) {
				   try {
					 InetAddress hostTmp = InetAddress.getByName( dp.getMachinesPanel().getDescriptionPanel().machine.getText());
					 if( hostTmp instanceof Inet6Address ) {
						 if( ((Inet6Address)hostTmp).isIPv4CompatibleAddress() ) {
							System.out.println("L'adresse IPv6 fournit est une adresse IPv4 compatible IPv6");
						 }
						else {
								System.out.println("This is a native ipv6 address.");
						 }
					 }
					 else {
					 	MessageManager.warningMessage( hostTmp.getHostAddress() + " is an IPv4 address.", true);
					 }
					}
					 catch (UnknownHostException uhe) { uhe.printStackTrace();  }
					 catch (ClassCastException cce) {  cce.printStackTrace();   }
				   }
		}
		else if (source == dp.cosC) {

			if (e.getStateChange() == ItemEvent.DESELECTED) {
				dp.cos.setText("");
			   	dp.cos.setEditable(false);
		   }
	   		else {
		  		 dp.cos.setEditable(true);
	  		 }
   }
   }
  }
