package graphics2.listener.generator;

/**
 *  MMPPNGeneratorConstructor
 * 
 * @author mladoue
 * @version 0.1, 18/11/02
 */

import java.io.IOException;

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;


import multimedia.generation.*;
import multimedia.model.*;
import graphics2.*;
import multimedia.codec.*;


public class MMPPNGeneratorConstructor extends SimpleModelGeneratorConstructor{

	protected int startState,etatCount; 
	protected double alpha, beta, lambda1;
	
	public MMPPNGeneratorConstructor(GestionTest gt, Element nFlow) {
		super(gt, nFlow);
	}
	
	public void setModelParameters(Element model) {
		System.out.println("Model node: " + model.toString()); //DEBUG
		NodeList nl = model.getChildNodes(); 
		for (int i=0; i < nl.getLength(); i++) {
			String name =  nl.item(i).getNodeName();
			if (name.equals("statenumber")) {
				etatCount = (Integer.valueOf( ((org.w3c.dom.Element) nl.item(i)).getAttribute("value")).intValue() );
			}
			else if (name.equals("sstate")) {
				startState = (Integer.valueOf( ((org.w3c.dom.Element) nl.item(i)).getAttribute("value")).intValue() );
			}
			else if (name.equals("snumber")) {
				etatCount = Integer.parseInt(((Element) nl.item(i)).getAttribute("value"));	
			}
			else if(name.equals("alpha")) {				
				alpha = Double.valueOf(((Element) nl.item(i)).getAttribute("value")).doubleValue();
			}												
			else if(name.equals("beta")) {
				beta = Double.valueOf(((Element) nl.item(i)).getAttribute("value")).doubleValue();		
			}
			else if(name.equals("lambda1")) {
				lambda1 = Double.valueOf(((Element) nl.item(i)).getAttribute("value")).doubleValue();	
			}
			else {
				System.err.println("Error: unknown parameters!" + name);
			}
		}
	}
	
	/**
	 * constructModelGenerator : 
	 * 		- cree le model
	 * 		- cree le model generator
	 * @throws IOException
	 */
 	public void constructModelGenerator() throws IOException {
		MMPPNModel mmppnm = new MMPPNModel(etatCount, startState, alpha, beta, (AudioCodec)codec);
			// User can specify a lambda that is different of 1/codec.getTpsIP()
		if (lambda1 != (1d/(((AudioCodec)codec).getTpsIP()))) {
			mmppnm.setParam("lambda", lambda1);
		}
		MMPPNGeneration mmppng = new MMPPNGeneration(mmppnm, duration, 1, fileName, true); //srcNumber is unused
		genericAggModel = mmppnm;
		genericGen = mmppng;
 	}
}
