package graphics2.panel.client.model;

/**
 * MMPP2ModelPanel
 * 
 * @author mladoue
 * @version 0.1, 10/01/03 
 */




import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;

import utils.MessageManager;
import graphics2.panel.client.InterneModelPanel;

public class MMPP2ModelPanel extends  GenericModelPanel {

	private JLabel[] paramName = new JLabel[4];  // alpha, beta and lambda1, lambda2
  	private JTextField[] paramValue = new JTextField[4];
	private JLabel etatDepartL = new JLabel("Start state : ");
	private JTextField etatDepartF = new JTextField("1",7);
    
	/**
 	* MMPP2ModelPanel : default constructor
	 */
	public MMPP2ModelPanel() {
		super();
	  	modelType = AUDIO;
	  	modelParametersNumber = 5;
	}
			
	/**
	 * MMPP2ModelPanel
	 * 
	 * @param imp
	 */
	public MMPP2ModelPanel (InterneModelPanel imp) {
            super(imp);
            modelType = AUDIO;
            modelParametersNumber = 5;
            
	    JPanel mmpp2Panel = new JPanel();
		mmpp2Panel.setLayout( new BoxLayout(mmpp2Panel, BoxLayout.Y_AXIS) );
	
		this.setLayout( new BoxLayout(this,BoxLayout.Y_AXIS) );	    
	    
	    JPanel panel1 = new JPanel();
	    panel1.setLayout(new BoxLayout(panel1,BoxLayout.X_AXIS));
	    
      	paramName[0] = new JLabel("Alpha : ");
   		paramName[0].setHorizontalAlignment(JLabel.RIGHT);
   		paramName[0].setAlignmentX(LEFT_ALIGNMENT);
   		panel1.add( Box.createRigidArea(new Dimension(41,0)) );	
   		panel1.add( paramName[0] );
 		panel1.add(Box.createRigidArea(new Dimension(40,0)));
    	panel1.add ( paramValue[0] = new JTextField("",7) );		
		paramValue[0].setMaximumSize(new Dimension(paramValue[0].getPreferredSize().width, 
																				  paramValue[0].getPreferredSize().height));
		panel1.add(Box.createHorizontalGlue());
		
		  
	    JPanel panel2 = new JPanel();
	    panel2.setLayout(new BoxLayout(panel2,BoxLayout.X_AXIS));
		paramName[1] = new JLabel("Beta : ");
      	paramName[1].setHorizontalAlignment(JLabel.RIGHT);
      	paramName[1].setAlignmentX(LEFT_ALIGNMENT);  	
      	panel2.add(Box.createRigidArea(new Dimension(40,0)));		
        panel2.add( paramName[1] );
        panel2.add(Box.createRigidArea(new Dimension(50,0)));
      	panel2.add( paramValue[1] =new JTextField("",7));
      	paramValue[1].setMaximumSize(new Dimension(paramValue[1].getPreferredSize().width, 
      																			  paramValue[1].getPreferredSize().height));
      	panel2.add(Box.createRigidArea(new Dimension(94,0)));
		panel2.add(MessageManager.createHelpMessageDialogButton("Help window...to do"));
		panel2.add(Box.createHorizontalGlue());
      	
      	JPanel panel3 = new JPanel();
	    panel3.setLayout(new BoxLayout(panel3,BoxLayout.X_AXIS));
      	paramName[2] = new JLabel("Lambda1 : ");
      	paramName[2].setHorizontalAlignment(JLabel.RIGHT);
      	paramName[2].setAlignmentX(LEFT_ALIGNMENT);  	
      	panel3.add(Box.createRigidArea(new Dimension(40,0)));		
        panel3.add( paramName[2] );
        panel3.add(Box.createRigidArea(new Dimension(20,0)));
      	panel3.add ( paramValue[2] = new JTextField("",7));
		paramValue[2].setMaximumSize(new Dimension(paramValue[2].getPreferredSize().width, 
																				  paramValue[2].getPreferredSize().height));
		panel3.add(Box.createHorizontalGlue());
      	
      	JPanel panel4 = new JPanel();
	    panel4.setLayout(new BoxLayout(panel4,BoxLayout.X_AXIS));
      	paramName[3] = new JLabel("Lambda2 : ");
      	paramName[3].setHorizontalAlignment(JLabel.RIGHT);
    	 paramName[3].setAlignmentX(LEFT_ALIGNMENT);  		
    	 panel4.add(Box.createRigidArea(new Dimension(40,0)));	
        panel4.add( paramName[3] );
        panel4.add(Box.createRigidArea(new Dimension(20,0)));
      	panel4.add ( paramValue[3] = new JTextField("",7));
		paramValue[3].setMaximumSize(new Dimension(paramValue[3].getPreferredSize().width, 
																				  paramValue[3].getPreferredSize().height));
		panel4.add(Box.createHorizontalGlue());

 
  		JPanel panel5 = new JPanel();
	    panel5.setLayout(new BoxLayout(panel5,BoxLayout.X_AXIS));
	    panel5.add(Box.createRigidArea(new Dimension(41,0)));	
    	panel5.add(etatDepartL );
    	panel5.add(Box.createRigidArea(new Dimension(12,0)));
    	panel5.add(etatDepartF);
		etatDepartF.setMaximumSize(new Dimension(etatDepartF.getPreferredSize().width, 
																			  etatDepartF.getPreferredSize().height));

		panel5.add(Box.createHorizontalGlue());

		mmpp2Panel.add(panel5);
		mmpp2Panel.add(Box.createRigidArea(new Dimension(0,5)));
		mmpp2Panel.add(panel1);
		mmpp2Panel.add(Box.createRigidArea(new Dimension(0,5)));
		mmpp2Panel.add(panel2);
		mmpp2Panel.add(Box.createRigidArea(new Dimension(0,5)));
		mmpp2Panel.add(panel3);
		mmpp2Panel.add(Box.createRigidArea(new Dimension(0,5)));
		mmpp2Panel.add(panel4);
		mmpp2Panel.add(Box.createRigidArea(new Dimension(0,5)));
		
		add(mmpp2Panel);
	
		 // Set the Border
    	setBorder( new TitledBorder("MMPP-2 Model features") );
	
	}

	/**
	 * Method getStartState.
	 * @return int
	 */
    public int getStartState() {
		return Integer.parseInt(etatDepartF.getText());  //initialize to 1 by default
	}
	
	/**
	 * Method getParam.
	 * @param idx 0: alpha, 1:beta, 2:lambda1 3:lambda2
	 * @return double
	 */
	public double getParam(int idx) throws IllegalArgumentException {
		String ans = "";
		if(idx>3 || idx<0) {
     		throw new IllegalArgumentException("There isn't " + idx + " parameter");
     	}
     	else {
     			ans = paramValue[idx].getText();
     			if ( ans.equals("") || ans.equals(" ") ) {
     				ans = "0";	
     			} 
			return Double.parseDouble(ans);
     	}
	}
	
     public void setStartState(int state) throws IllegalArgumentException {
		etatDepartF.setText("" + state);
	}
	/**
	 * Method setParam.
	 * @param idx 0: alpha, 1:beta, 2:lambda1 3:lambda2
	 * @param value
	 * @throws IllegalArgumentException
	 */
     public void setParam(int idx, double value) throws IllegalArgumentException {
     	if(idx>3 || idx<0) {
     		throw new IllegalArgumentException("There isn't " + idx + " parameter");
     	}
     	else {
     		System.out.println("++"+paramValue.length);
     		String chaine=""+value;
			paramValue[idx].setText(chaine);
     	}
	} 

   public void setParams(String[] values) throws IllegalArgumentException {
  	 	if (values.length == modelParametersNumber ) {
   			for(int i=0;i<values.length;i++) {
				paramValue[i].setText(values[i]);
   			}
   		}
   		else {
			throw new IllegalArgumentException("You don't have the good argument number : " + values.length);	
		}
	} 

  
  public void freezeInfo(boolean b) {
  	for (int i=0;i<4;i++) {
  		paramValue[i].setEditable(!b);
  	}
  	etatDepartF.setEditable(!b);
  }
  
  public void reset() {
	 for (int i=0;i<4;i++) {
		 paramValue[i].setText("");
	 }
	 etatDepartF.setText("1"); // default value
   }


	
	/**
	 * Check the different parameters of this model
	 */
	public boolean isAValidModel() {
		if (isAnInt(etatDepartF.getText(),"State Start") &&
			isAFloat(paramValue[0].getText(), "Alpha") &&
			isAFloat(paramValue[1].getText(), "Beta") &&
			isAFloat(paramValue[2].getText(), "Lambda1") &&
			isAFloat(paramValue[3].getText(), "Lambda2")) {
				// Check also that etatDepart is 0 or 1
				int etat = Integer.parseInt(etatDepartF.getText());
				if (etat!=1 && etat !=0) {
					JOptionPane.showMessageDialog(this, "State Start must be 0 or 1!","Wrong value",JOptionPane.ERROR_MESSAGE);
					return false;
				}
				return true;
			}
			else
				return false;
	}
	
    public org.w3c.dom.Element buildNewXmlNode() {
            // data values in the Panel should be ok
            // Access Configuration Tree.
        graphics2.ConfigurationXMLFile conftree = imp.getModelPanel().getClientPanel().getListScenario();
        org.w3c.dom.Element elem = conftree.createNewXMLElement("scenario_mmpp2");
        
            // Add the model.
        org.w3c.dom.Element modelchild = conftree.createElement("model");
        modelchild.setAttribute("name", "MMPP2");
        elem.appendChild(modelchild);

            // Add state value node to the model
        org.w3c.dom.Element statechild = conftree.createElement("sstate");
        statechild.setAttribute("value", String.valueOf(getStartState()));
        modelchild.appendChild(statechild);

            // Add alpha value node to the model
        org.w3c.dom.Element alphachild = conftree.createElement("alpha");
        alphachild.setAttribute("value", paramValue[0].getText());
        modelchild.appendChild(alphachild);

            // Add beta value node to the model
        org.w3c.dom.Element betachild = conftree.createElement("beta");
        betachild.setAttribute("value", paramValue[1].getText());
        modelchild.appendChild(betachild);

            // Add lambda1 value node to the model
        org.w3c.dom.Element lambda1child = conftree.createElement("lambda1");
        lambda1child.setAttribute("value", paramValue[2].getText());
        modelchild.appendChild(lambda1child);

            // Add lambda2 value node to the model
        org.w3c.dom.Element lambda2child = conftree.createElement("lambda2");
        lambda2child.setAttribute("value", paramValue[3].getText());
        modelchild.appendChild(lambda2child);

            // Return the new XML node
        return elem;
    }
	
	public void updateWithXmlNode(org.w3c.dom.Element elt) {
		if (! elt.getAttribute("name").equals("MMPP2")) {
			// Error
			System.out.println("Wrong model name: "+elt.getAttribute("name")+" in MMPP2ModelPanel");	
		}
		else {
			/* @param idx 0: alpha, 1:beta, 2:lambda1 3:lambda2
			* @param value
			* @throws IllegalArgumentException
			*/
			//reset();
			org.w3c.dom.NodeList nlist = elt.getChildNodes() ;
			for (int i=0; i < nlist.getLength(); i++) {
				String name = nlist.item(i).getNodeName();
				System.out.println(")))) "+name);
				if (name.equals("sstate"))
					setStartState(Integer.valueOf( ((org.w3c.dom.Element) nlist.item(i)).getAttribute("value")).intValue() );
				else if(name.equals("alpha")) 
					setParam(0, Double.valueOf(((org.w3c.dom.Element) nlist.item(i)).getAttribute("value")).doubleValue());
				else if(name.equals("beta"))
					setParam(1, Double.valueOf(((org.w3c.dom.Element) nlist.item(i)).getAttribute("value")).doubleValue());
				else if(name.equals("lambda1"))
					setParam(2, Double.valueOf(((org.w3c.dom.Element) nlist.item(i)).getAttribute("value")).doubleValue());
				else if(name.equals("lambda2"))
					setParam(3, Double.valueOf(((org.w3c.dom.Element) nlist.item(i)).getAttribute("value")).doubleValue());
			}
		}
	}
	
	/**public static void main(String[] args) {
		java.util.Hashtable listModel = new java.util.Hashtable();
		ModelPanel mp = new ModelPanel(listModel);
		InterneModelPanel imp = new InterneModelPanel(mp);
		new MMPP2ModelPanel(imp);
	}
	*/
}
