package graphics2.panel.control;


import java.awt.*;
import javax.swing.*;

import graphics2.info.*;
import graphics2.*;

/**
 * In this panel, we defines some parameters...
 * 
 * @author mladoue
 * @version 0.1, Jun 13, 2003
 */


public class ControlPanel extends JPanel implements ControlInfo {

	//	JFrame auquel sera attache le JPanel
	 protected GestionTest gestionTest;
	 protected ScenarioFilePanel scenariofilePanel;
	 protected FileTestParametersPanel fileTestParametersPanel;
	 
	 
	 public ControlPanel(GestionTest gestionTest) {
		this.gestionTest = gestionTest;
	 	
		JPanel cPanel = new JPanel();
		cPanel.setLayout( new BoxLayout(cPanel,BoxLayout.Y_AXIS) );
	
		JScrollPane scroller = new JScrollPane(cPanel);
		this.setLayout( new BorderLayout() );
    	
		JPanel panel1 = new JPanel();
		panel1.setLayout( new BoxLayout( panel1, BoxLayout.X_AXIS) );
//		//panel1.setPreferredSize(new Dimension(600,20));

		panel1.add(fileTestParametersPanel = new FileTestParametersPanel() );
    	
		JPanel panel2 = new JPanel();
		panel2.setLayout( new BoxLayout( panel2, BoxLayout.X_AXIS) );
		
		scenariofilePanel = new ScenarioFilePanel();
		panel2.add(scenariofilePanel);
		
//JPanel panel3 = new JPanel();
//panel3.setLayout( new BoxLayout( panel3, BoxLayout.X_AXIS) );
		
		cPanel.add(panel1);
		cPanel.add(Box.createRigidArea(new Dimension(0,5)));
		cPanel.add(panel2);
		cPanel.add(Box.createVerticalGlue());
		//cPanel.add(panel3);
		
	 	add(scroller);
	 }
	 
	public ScenarioFilePanel getScenarioFilePanel() { return scenariofilePanel; }
	public FileTestParametersPanel  getFileTestParametersPanel() { return fileTestParametersPanel; }

	public void freezeInfo(boolean b) {
		fileTestParametersPanel.freezeInfo(b);
		scenariofilePanel.freezeInfo(b);
	}
	
	public void reset() {
		fileTestParametersPanel.reset();
		scenariofilePanel.reset();
	}

	
//	Permet de recuperer le nom du scenario pour l'ajouter dans ModelsListPanel
 public String getResultFileName() { return scenariofilePanel.getScenarioFileName(); }
 public String getResultDirectory() { return scenariofilePanel.getResultDirectory();}

}