package graphics2.panel.experiment;

import graphics2.listener.MyCheckBoxListener;

import java.awt.*;
import java.util.Enumeration;
import java.util.Hashtable;

import javax.swing.*;


/**
 * 
 * @author mladoue
 * @version 0.1, Jun 13, 2003
 */
public class DescriptionPanel extends JPanel {
	
	
	protected MachinesPanel mp;
	protected MyCheckBoxListener cbl = new MyCheckBoxListener(this);
	
	protected JLabel machineL;
	public JTextField machine = new JTextField("", 20);

	protected JLabel cosL = new JLabel("Cos: ");
	protected JLabel ipaddressL = new JLabel("IP address: ");
	public JTextField cos = new JTextField("0",5);
	protected JTextField ipaddress = new JTextField("",25);
	public JCheckBox cosC = new JCheckBox("cos");
	public JCheckBox ipv6 = new JCheckBox("ipv6");
	protected JLabel portL = new JLabel("Port number: ");
	protected JTextField port = new JTextField("5000", 5);
	
	protected JLabel scenarioL = new JLabel("Scenario:");
	public JComboBox scenarioName = new JComboBox();
	
	protected JComboBox accessType = new JComboBox();
	protected Hashtable listAccess;
	protected JPanel dPanel = new JPanel();
	
	// correspond a la partie commune Server/Client
	protected JPanel d1Panel = new JPanel();
	// correspond a la partie specifique du client et du server
	protected JPanel d2Panel = new JPanel();
	
	protected JPanel ipaPanel = new JPanel(); // ipAdress Panel
	protected JPanel cosPanel = new JPanel(); // cos Panel
	protected JPanel namePanel = new JPanel(); //Name

	
	public DescriptionPanel( MachinesPanel mp) {
		
		this.mp = mp;
		
		this.setLayout(new BoxLayout( this, BoxLayout.Y_AXIS));
		
		makeComboBox();
		
		dPanel.setLayout( new BoxLayout( dPanel, BoxLayout.Y_AXIS) );
		d1Panel.setLayout( new BoxLayout( d1Panel, BoxLayout.Y_AXIS) );
		
		machineL = new JLabel("Machine name: ");

		JPanel line1 = new JPanel();
		line1.setLayout(new BoxLayout(line1, BoxLayout.X_AXIS));
		namePanel.setLayout(new BoxLayout(namePanel, BoxLayout.X_AXIS));
		namePanel.add(machineL);
		namePanel.add(Box.createRigidArea(new Dimension(10, 0)));
		namePanel.add(machine);
		JPanel pPanel = new JPanel(); // port Panel
		pPanel.setLayout(new BoxLayout(pPanel, BoxLayout.X_AXIS));
		pPanel.add(portL);
		pPanel.add(Box.createRigidArea(new Dimension(10, 0)));
		pPanel.add(port);
		line1.add( Box.createRigidArea( new Dimension(20,0)) );
		line1.add(namePanel);
		line1.add( Box.createRigidArea( new Dimension(20,0)) );
		line1.add(pPanel);	


		// IP@ panel definition
		ipaPanel.setLayout( new BoxLayout( ipaPanel, BoxLayout.X_AXIS) );
		ipaPanel.add( ipaddressL );
		ipaPanel.add( Box.createRigidArea( new Dimension(10,0)) );
		ipaPanel.add( ipaddress );
		
		
		JPanel line2 = new JPanel();
		line2.setLayout(new BoxLayout(line2, BoxLayout.X_AXIS));
		line2.add(Box.createRigidArea( new Dimension(10,0)));
		line2.add(ipaPanel);	
		line2.add(Box.createRigidArea( new Dimension(10,0)));
		line2.add(accessType);

		d1Panel.add(Box.createRigidArea(new Dimension(20, 5)));
		d1Panel.add(line1);
		d1Panel.add(Box.createRigidArea( new Dimension(10,5)));
		d1Panel.add(line2);	
	}

public void makeComboBox() {
	
	//	Liste des acces possibles
	listAccess = new Hashtable();
	 try {
		listAccess.put("RemoteShell","rsh");
		listAccess.put("SecurisedShell","ssh");
	 }
	 catch (NullPointerException e) { 
		 System.out.println("DescriptionPanel.constructor :" + e.toString());
	 }
	 
	Enumeration valModelName = listAccess.elements();  // pour acceder aux elements de la HashTable 

		while(valModelName.hasMoreElements()) {
			accessType.addItem(valModelName.nextElement());
		}

		accessType.setEditable(false);
		accessType.setSelectedIndex(0);
		accessType.setMaximumRowCount(2);
		//accessType.addActionListener(this);
		//accessType.addItemListener(cblModelName = new ModelNameListener());
}

public void updateScenarioList(Object[] newnames) {
	scenarioName.removeAllItems();
	if (newnames.length > 0) {
		for (int i=0; i < newnames.length;i++) {
			scenarioName.addItem(newnames[i].toString());
		}
		scenarioName.setEditable(false);
		scenarioName.setSelectedIndex(0);
	}
	scenarioName.setMaximumRowCount(newnames.length);
}

public MachinesPanel getMachinesPanel() { return mp; }

public void freezeInfo(boolean b) {
	cos.setEnabled(!b);
	ipaddress.setEnabled(!b);
	
}

public void reset() {
	cos.setText("");
	ipaddress.setText("");

	
}


}
