/**
 * AudioCodec : Definition des Codecs Audio
 * 					There are defined by: a packet size (in bytes) and an Inter-Packet time (in seconds)
 * 
 * @author maria ladoue
 * @version 0.1, 04/07/02
 */

package multimedia.codec;

public class AudioCodec extends CodecAV {

    public int taille;   // en octets
    public double tpsIP; // en s

    public static int SIZE = 0;
    public static int IPTIME = 1;

// Definition des constructeurs

/**
 * AudioCodec : Consctructeur par defaut  
 */
    public AudioCodec() {
		name = new String("Audio");// Le codec par defaut est G711
		paramNames = new String[2];

		paramNames[SIZE] = new String("Packet Size");
		paramNames[IPTIME] = new String("Inter-Packet Time");
		taille = 124;  // in Bytes
		tpsIP = 0.012;  // in seconds
    }

    /**
     * AudioCodec : defines packet size and inter-packet time 
     * @param size defines size of packets (in bytes)
     * @param IPTime defines Inter-packet time (in seconds)
     */
    public AudioCodec( int size , double IPTime ) {
		this();
		taille = size;
		tpsIP = IPTime;
    }

    /**
     * AudioCodec : defines packet size and inter-packet time 
     * @param size defines size of packets (in bytes)
     * @param IPTime defines Inter-packet time (in seconds)
     * @param nameCodec defines the name of codec
     */
    public AudioCodec( int size , double IPTime, String nameCodec ) {
		this(size,IPTime);
		name = nameCodec;
    }

    // Definition de quelques methodes

    public int getSize() { return taille;  }

    public void setSize( int uneTaille ) {	taille = uneTaille;   }

    public double getTpsIP() { return tpsIP;  }

    public void setTpsIP( double unTpsIP ) {  tpsIP = unTpsIP;   } 
    
    public String toString() { return new String(getName() + " " + getSize() + " " + getTpsIP());   }

    /**
     * Methode: Main pour tester la classe
     */

    public static void main (String[] args) {
	AudioCodec c1 = new AudioCodec();
	c1.getSize();
	System.out.println(c1.getParamName(0) + " " + c1.getParamName(1));
    } // fin de la methode main


}
