/**
 *  IPPGeneration : Pour creer un scenario de generation de paquets suivant le modele IPP
 *                  Remarque: cela marche mieux si on ne genere pas un paquet des qu'on entre dans un nouvel etat
 *		NOT USED
 *
 * @author maria ladoue
 * @version 0 , 25/09/02 
 */

package multimedia.generation;

import java.io.*;
import java.util.Date;

import utils.*;
import multimedia.codec.*;
import multimedia.model.*;


public class IPPGeneration extends GenericGeneration implements AudioCodecExample { 

    protected MMPP2Model model;
  

    public IPPGeneration ( MMPP2Model model, int tpsSimul, String fichierReq, int srcNumber) throws IOException {	
		this.model = model;
		this.tpsSimul = tpsSimul;
		this.fileName = fichierReq;
		this.srcNumber = srcNumber;
    }
    
 
    /**
     * To generate a file either playable or informative<BR>
     * 	date: t + 0.000000 s    IA: 0.000000 s <BR>
     * 
 	 *@param playable
     *@return throughput in bytes/s<BR>
     */

	protected double scenarioGenericGeneration( boolean playable) throws IOException {
		
		// Definition des variables
		int packetSize = model.codec.getSize();
		double time = 0, sOld = 0, r, T1 = 0, T2 = 0;
		int newTpsSimul = tpsSimul*60;
		int etat = model.getEtatDepart();		
		int nbPacket2 = 0, nbPeriod = 0, nbBytes = 0, cpt = 0;
		double tpsIP2 = 0;
		
		//		double debitIns = 0;
		//		double ia = 0;
	
		if(!playable) {
			// Premiere ligne du scenario: date + nom_du_serveur
			fichierReq.write( new Date().toString() + " \t requested document : " + fileName + "\n");
			fichierReq.write( model.getCompleteName() + "\t Test Duration : " + tpsSimul + "mn \t \n");
			fichierReq.write("Scenario format: date (in seconds) \t Inter-Packet Time(in milliseconds) \t packet size(in bytes) \n\n" );// Format du fichier scenario
		}
			    
		while (time < newTpsSimul) {
		   
		    if (etat == 0) {	// pas d'emission pdt l'etat 0 <=> 1 
				// Duree de l'etat 1
				T1 = model.calculT( model.getParam(0,"beta") );
				etat = 1;
				time += T1;	
		    } // fin du if
		    
		    else {
				r = time;
				// Duree de l'etat 2
				T2 = model.calculT( model.getParam(1,"alpha") );
		
				// Moins efficace si on genere un paquet des qu'on entre dans un etat
				//fichierReq.write("date: t + " + r + " s \t IA: " + ( r - sOld) + " s \n");
				//nbPacket2++;
			
				while ( r < Math.min( time + T2 , newTpsSimul) ) {
				    // Temps inter-paquet pour etat 2
				    tpsIP2 = model.calculT(model.getParam(1,"lambda"));
				    
				    if ( tpsIP2 != 0d ) {
						if ( (tpsIP2+r) < (time+T2) ) { 
							if( playable) {  
								fichierReq.write( (tpsIP2+(r-sOld))*1000 + "\t" + packetSize + "\n");
							}
							else {
					    		fichierReq.write("date: t + " + (r+tpsIP2) + " s \t IA: " +(tpsIP2+(r-sOld))*1000 + " ms" +  packetSize  + " Bytes \n");  //(tpsIP2+(r-sOld))*1000 insted of tpsIP2*1000
							}
					    nbPacket2++; // Pour calculer le debit moyen...
					    r += tpsIP2;
						}
					else { break;  }
				    }
				}// fin du while
		
				sOld =  r;
				etat = 0;
				time += T2;
		    } // fin du else
		
		    if (cpt != 1 ) { cpt++;  }
		    
		    else {
			nbPeriod++;
			// Calcul du debit moyen: debitmoy = ((n-1)* debitmoy(n-1) + debitIns(n))/n
			
			//debitIns = (modelName.getCodec()).getTaille()*nbPacket2/(T1 + T2) ; // Donner le debit instantane pour une periode: T1 + T2
			//System.out.println("DebitIns: " + debitIns/1000 + " kB/s" );
			//debit = ( (nbPeriod - 1)*debit + debitIns )/nbPeriod;
	      		//double meanIAIns = (tpsIP1 + tpsIP2)/nbPaquets2;		//System.out.println("mean IA: " + meanIAIns);
			
			//System.out.println("Le debit moyen est de: " + debit  + " octets/s " + "soit :" + debit*8/1000  + " kbits/s" );
				      
			nbBytes += nbPacket2*packetSize;
			//System.out.println("Nb d'octets:" + nboctet);
			//ia += tpsIP1 + tpsIP2;
			nbPacket2 = 0;
			cpt = 0;
		    }// fin du else
		    
		} // fin du while
		
		fichierReq.flush();
		fichierReq.close();
	
		double debit =  nbBytes/time;
		
		if ( !playable ) {
			System.out.println("Le debit moyen est de: " + debit/1000  + " kB/s, soit : " + debit*8/1024  + " kb/s" );
			//System.out.println("Le debit moyen est de: " + (nboctet/tpsSimul/1000)  + " kB/s, soit : " + nboctet/tpsSimul*8/1024  + " kb/s" );
			//System.out.println("IA moy: " + time/nboctet*(modelName.getCodec()).getTaille() );
			System.out.println("Debit theorique: " + Math.round(model.meanRate()) + " kb/s");
		}
	
		
		
		MessageManager.informationMessage("File created as: " + resultFile.getCanonicalPath(), graphic);
		
		return debit;
	
    }// fin de scenarioGenericGeneration( playable, serverName, serverPort)
    
/**
 * Methode: Main pour tester la classe
 */

    public static void main (String[] args) throws IOException {

	String s1 = "IPPGene";

	MMPP2Model ipp1 = new MMPP2Model(1,2.8409091,1.5384615,new AudioCodec(1000,0.03));
	IPPGeneration g1 = new IPPGeneration(ipp1,90,s1,1);

	//MMPP2Model ipp12 = new MMPP2Model(1,3.12,0.78,new AudioCodec(1000,0.25));
	//IPPGeneration g12 = new IPPGeneration(ipp12,25,fw1);

	//MMPP2Model ipp2 = new MMPP2Model(1,2d,1d,new AudioCodec(1000,10));
	//IPPGeneration g2 = new IPPGeneration(ipp2,1,fw1);

	g1.statisticsGeneration();
	g1.scenarioGeneration();
    }


}
