package statistic.distribution;

/**
 * ServiceTimeDistribution
 * 
 * @author mladoue
 * @version 0.1
 */

import java.util.Vector;

import statistic.function.*;


public abstract class ServiceTimeDistribution extends GenericDiscreteDistribution {
	
	//Create a vector where we'll stock sumCdf(k) of rank k
     int size = 5;
     Vector F = new Vector(size);

	
	/**
	 * Method pdf.  Pour etre conforme a  GenericDiscreteDistribution
	 * @param k
	 * @return 0  Not implemented
	 */
    public double pdf(int k) { return 0d;   }  // To do
	
	 public double getSumCdf(int k)   throws IllegalArgumentException {
     	if ( (getInitialisationStatus() == true) &&( k>=0) && ( k <=getKMAX(KFACTOR)  ))  {
     		
     		if(  k>=F.size() ) {
 				initializeSumCdf(F.size() +1, k);
 			}
     		return ((Double)(F.elementAt(k))).doubleValue();
     	}
     	else  {
 		throw new IllegalArgumentException("ServiceTimeDistribution. getSumCdf : you have to SigmaDistribution.initializeSumCdf(a,b) and 0< k <" + (getKMAX(KFACTOR) +1)+ " , " + k  + " , " + cdf + "  "+ F.size());
 	}
    }

	public void initializeSumCdf(int a,int b)  {
   	 		F.add(0, new Double(0));
   		 	double sumCdf = 0d;
   		 	
    		for (int l=a;l<=b;l++) {
				sumCdf += cdf(l);
				F.insertElementAt(new Double(sumCdf), l);
	    	}
    }
    
     public double getFMAX()  throws IllegalArgumentException {
     	if ( getInitialisationStatus() == true ) {
     		int KMAX = getKMAX(KFACTOR);
     		if (F.size() < KMAX) {
     			initializeSumCdf((F.size() +1), KMAX);
    		}
     		return getSumCdf(KMAX);
     	}
     	else  {
 			return super.getFMAX();
 		}
     }
    
       
	/**
	 * Method var : Not implemented
	 * @see statistic.GenericDistribution#var()
	 * @return 0
	 */
    public double var() { return 0d; }  // To do
    
    
    public  abstract double cdf(int k) throws IllegalArgumentException;
    
    public abstract double mean();
  	
  	public abstract GenericFunction getAutocorr();
		
}
