/**
 * GenericFunction : Definition des fonctions permettant de definir ro (fonction d'autocorrelation) 
 *
 * @author maria ladoue
 * @version 0.1, 01/09/02 
 */

package statistic.function;


public abstract class GenericFunction {
	
    /**
     * Function name: (i.e. markovian, SRD or LRD)<BR>
     */
    protected String name;
    protected double b;

    //Constructeur par defaut
    public GenericFunction() {
    	name = "Function";
    }

    public GenericFunction(double b) {
		if (b>0) {
	    	this.b = b;
		}
		else {
	    	throw new IllegalArgumentException("GenericFunction.constructor : b must be greater than 0.");
		}
    }
    
    public String toString() { return new String(getName() + " form : " +  getParam() ); }
    
    
    /**
     * Renvoie et fixe le nom du modele e la fonction
     */
    public String getName() { return name; }
    public void setName(String unNom) { name = unNom; }

    /**
     * Renvoie et fixe b
     */
    public double getParam() { return b; }
    public void setParam(double b) {this.b = b; }

    public abstract double function(int k);
    public abstract String getEquation();

}
