/**
 * MarkovianFunction : Definition de fonctions de la forme exp(-b*k)
 *
 * @author maria ladoue
 * @version 0.1, 01/09/02 
 */

package statistic.function;

import java.lang.Math;

public class MarkovianFunction extends GenericFunction {

    /**
     * Function type:
     *   f(k) = exp(-b*k) where b>0
     */
    
 	public MarkovianFunction() {
		super();
		name = new String("Markovian");
	}

    public MarkovianFunction(double b) {
	this();
	this.b = b;
    }

    public double function(int k) throws IllegalArgumentException {
	if (k>=0) {
	    return Math.exp(-b*k);
	}
	else {
	    throw new IllegalArgumentException("MarkovianFunction.function : define for k>=0.");
	}
    }

 public String getEquation() {
    	return new String("f(k) = exp(-b*k) where b>0");
    }

}
