/**
 * SRDFunction : Definition de fonctions de la forme exp(-b*sqrt(k))
 *
 * @author maria ladoue
 * @version 0.1, 01/09/02 
 */

package statistic.function;

import java.lang.Math;

public class SRDFunction extends GenericFunction {

    /**
     * Function type:
     *   f(k) = exp(-b*sqrt(k)) where b>0
     */

	 public SRDFunction() {
		super();
		name = new String("SRD");
	 }
	 
    public SRDFunction(double b) {
		this();
		if (b>0) { this.b = b; }
		else { throw new IllegalArgumentException("SRDFunction.function : define on for b>0."); }
    }

    public double function(int k) throws IllegalArgumentException {
		if (k>=00) {
		    return Math.exp(- b * Math.sqrt(k));
		}
		else {
	    	throw new IllegalArgumentException("SRDFunction.function : define on for k>=0.");
		}
    }

  public String getEquation() {  	return new String("f(k) = exp(-b*sqrt(k)) where b>0");   }

}
