package temp;
import java.io.*;
import javax.swing.*;

import utils.*;

import java.util.*;


/**
 * BenchUDPScenarioPlayerC : 
 * 
 * Propose  l'utilisateur une JFileChooser pour choisir un fichier bench envoi de messages.
 * Procde ensuite au chargement des rsultats stocks dans ce fichier en mmoire.
 * 
 * @author maria ladoue
 * @version 0.1, 10/12/02
 */

public class BenchUDPScenarioPlayerC {

        //Tableau contenant les rsultats du bench.
        //Pour chaque message envoy contient sa date d'arrive.
        protected int[] benchResults;
        protected int longueurMessages;
        protected int nbMessages;
        protected int tailleBufferReception, tailleBufferEmission;
        protected int tailleBufferRceptionPaquet;
        protected String nomFichier;
        protected JFrame frame;
        //boolen indiquant l'tat du chargement d'un fichier
        protected boolean ok;

        /**
         * Initialise le chargement d'un fichier (sur le disque) correspondant aux rsultats d'un bench ping-pong.
         */
        public BenchUDPScenarioPlayerC(JFrame frame){
                this.frame=frame;
                ok=false;
                if (obtenirCheminFichier()){
                        ok=true;
                        lectureFichier();
                }
        }

        /**
        * Indique si le chargement d'un fichier a t effectu.
        * @return un boolen indiquant le bon chargement d'un fichier
        */
        public boolean chargementOk(){
                return ok;
        }

        /**
        * Renvoit les rsultats chargs en mmoire  partir du fichier bench envoi de messages.
        * @return un vecteur contenant tous ces rsultats
        */
        public Vector getResults(){
                Vector v = new Vector();
                v.add(benchResults);
                v.add(new Integer(longueurMessages));
                v.add(new Integer(nbMessages));
                v.add(new Integer(tailleBufferReception));
                v.add(new Integer(tailleBufferEmission));
                v.add(new Integer(tailleBufferRceptionPaquet));
                return v;
        }

        /**
        * Propose  l'utilisateur une boite de dialogue pour choisir le fichier  charger.
        * @return un boolen indiquant si l'utilisateur a valid son choix
        */
        protected boolean obtenirCheminFichier(){
                JFileChooser fc=new JFileChooser();
                fc.setCurrentDirectory(new File("."));
                fc.setFileFilter(new FiltreFichier("envoi-messages",".txt","fichier rsultat bench envoi de messages"));
                if (fc.showOpenDialog(frame)==JFileChooser.APPROVE_OPTION){
                        nomFichier=fc.getSelectedFile().toString();
                        return true;
                }
                else{
                        nomFichier=null;
                        return false;
                }
        }

        protected void lectureFichier(){
                try{
                        BufferedReader in=new BufferedReader(new FileReader(nomFichier));
                        //ATTENTION: pour lire une ligne, il faut deux readLine: un pour la ligne, un pour le '\r'
                        //Lecture de longueurMessages
                        String s=in.readLine();s=in.readLine();
                        s=in.readLine();s=in.readLine();
                        s=in.readLine();
                        StringTokenizer t=new StringTokenizer(s,"\r\t");
                        s=t.nextToken();
                        longueurMessages=Integer.parseInt(t.nextToken());
                        //Lecture de nbMessages
                        s=in.readLine();s=in.readLine();
                        t=new StringTokenizer(s,"\r\t");
                        s=t.nextToken();
                        nbMessages=Integer.parseInt(t.nextToken());
                        //Lecture de tailleBufferReception
                        s=in.readLine();s=in.readLine();
                        t=new StringTokenizer(s,"\r\t");
                        s=t.nextToken();
                        tailleBufferReception=Integer.parseInt(t.nextToken());
                        //Lecture de tailleBufferEmission
                        s=in.readLine();s=in.readLine();
                        t=new StringTokenizer(s,"\r\t");
                        s=t.nextToken();
                        tailleBufferEmission=Integer.parseInt(t.nextToken());
                        //Lecture de tailleBufferRceptionPaquet
                        s=in.readLine();s=in.readLine();
                        t=new StringTokenizer(s,"\r\t");
                        s=t.nextToken();
                        tailleBufferRceptionPaquet=Integer.parseInt(t.nextToken());
                        s=in.readLine();s=in.readLine();
                        s=in.readLine();s=in.readLine();
                        s=in.readLine();s=in.readLine();
                        s=in.readLine();s=in.readLine();
                        s=in.readLine();s=in.readLine();
                        s=in.readLine();s=in.readLine();
 
                        //lecture du tableau
                        benchResults = new int[nbMessages];
                        for (int i=0;i<nbMessages;i++){
                                s=in.readLine();s=in.readLine();
                                t=new StringTokenizer(s,"\r\t");
                                s=t.nextToken();
                                benchResults[i]=Integer.parseInt(t.nextToken());
                        }
 
                        in.close();
                }
                catch (FileNotFoundException e) {
                        System.out.println("BenchUDPS3C:lectureFichier"+e.toString());
                }
                catch (IOException e) {
                        System.out.println("BenchUDPS3C:lectureFichier"+e.toString());
                }
        }
 
        protected static void main(String args[]) {
                JFrame frame=new JFrame();
                GestionUDPS3C b=new GestionUDPS3C(frame);
        }
}

