/**
* Propose  l'utilisateur une JFileChooser pour choisir un fichier gestion ping-pong.
* Procde ensuite au chargement des rsultats stocks dans ce fichier en mmoire.
*/

package temp;
import java.io.*;
import javax.swing.*;

import utils.*;

import java.util.*;



public class GestionUDPS2C{
    //Tableau contenant les rsultats du gestion.
    //Contient pour chaque ping-pong sa dure.
    protected int[] rsultatsGestion;
    protected int min,max;
    protected  int longueurMessages;
    protected int nbPingPong;
    protected int tailleBufferReception, tailleBufferEmission;
    protected int tailleBufferRceptionPaquet;
    protected String nomFichier;
    protected JFrame frame;
    //boolen indiquant l'tat du chargement d'un fichier
    protected boolean ok;
    
    /**
     * Initialise le chargement d'un fichier sur le disque correspondant aux rsultats d'un gestion ping-pong.
     * @param frame la fentre parente
     */
    public GestionUDPS2C(JFrame frame) {
	this.frame=frame;
	ok=false;
	if (obtenirCheminFichier()){
	    ok=true;
	    lectureFichier();
	}
    }
    
    /**
     * Indique si le chargement d'un fichier a t effectu.
     * @return un boolen indiquant le bon chargement d'un fichier
     */
    public boolean chargementOk(){
	return ok;
    }
    
    /**
     * Renvoit les rsultats chargs en mmoire  partir du fichier gestion ping-pong.
     * @return un vecteur contenant tous ces rsultats
     */
    public Vector obtenirRsultats(){
	Vector v=new Vector();
	v.add(rsultatsGestion);
	v.add(new Integer(min));
	v.add(new Integer(max));
	v.add(new Integer(longueurMessages));
	v.add(new Integer(nbPingPong));
	v.add(new Integer(tailleBufferReception));
	v.add(new Integer(tailleBufferEmission));
	v.add(new Integer(tailleBufferRceptionPaquet));
	return v;
    }

    /**
     * Propose  l'utilisateur une boite de dialogue pour choisir le fichier  charger.
     * @return un boolen indiquant si l'utilisateur a valid son choix
     */
    protected boolean obtenirCheminFichier(){
	JFileChooser fc=new JFileChooser();
	fc.setCurrentDirectory(new File("."));
	fc.setFileFilter(new FiltreFichier("ping-pong",".txt","fichier rsultat gestion ping-pong"));
	if (fc.showOpenDialog(frame)==JFileChooser.APPROVE_OPTION){
	    nomFichier=fc.getSelectedFile().toString();
	    return true;
	}
	else{
	    nomFichier=null;
	    return false;
	}
    }

    protected void lectureFichier(){
	try{
	    BufferedReader in=new BufferedReader(new FileReader(nomFichier));
	    //ATTENTION: pour lire une ligne, il faut deux readLine: un pour la ligne, un pour le '\r'
	    //Lecture de min
	    String s=in.readLine();s=in.readLine();
	    s=in.readLine();s=in.readLine();
	    s=in.readLine();
	    StringTokenizer t=new StringTokenizer(s,"\r\t");
	    s=t.nextToken();
	    min=Integer.parseInt(t.nextToken());
	    //Lecture de max
	    s=in.readLine();s=in.readLine();
	    t=new StringTokenizer(s,"\r\t");
	    s=t.nextToken();
	    max=Integer.parseInt(t.nextToken());
	    //Lecture de longueurMessages
	    s=in.readLine();s=in.readLine();
	    t=new StringTokenizer(s,"\r\t");
	    s=t.nextToken();
	    longueurMessages=Integer.parseInt(t.nextToken());
	    //Lecture de nbPingPong
	    s=in.readLine();s=in.readLine();
	    t=new StringTokenizer(s,"\r\t");
	    s=t.nextToken();
	    nbPingPong=Integer.parseInt(t.nextToken());
	    //Lecture de tailleBufferReception
	    s=in.readLine();s=in.readLine();
	    t=new StringTokenizer(s,"\r\t");
	    s=t.nextToken();
	    tailleBufferReception=Integer.parseInt(t.nextToken());
	    //Lecture de tailleBufferEmission
	    s=in.readLine();s=in.readLine();
	    t=new StringTokenizer(s,"\r\t");
	    s=t.nextToken();
	    tailleBufferEmission=Integer.parseInt(t.nextToken());
	    //Lecture de tailleBufferRceptionPaquet
	    s=in.readLine();s=in.readLine();
	    t=new StringTokenizer(s,"\r\t");
	    s=t.nextToken();
	    tailleBufferRceptionPaquet=Integer.parseInt(t.nextToken());
	    s=in.readLine();s=in.readLine();
	    s=in.readLine();s=in.readLine();
	    s=in.readLine();s=in.readLine();
	    s=in.readLine();s=in.readLine();
	    s=in.readLine();s=in.readLine();
	    s=in.readLine();s=in.readLine();
	    
	    //lecture du tableau
	    rsultatsGestion=new int[nbPingPong];
	    for (int i=0;i<nbPingPong;i++){
		s=in.readLine();s=in.readLine();
		t=new StringTokenizer(s,"\r\t");
		s=t.nextToken();
		rsultatsGestion[i]=Integer.parseInt(t.nextToken());
	    }
	    
	    in.close();
	}
	catch (FileNotFoundException e) {
	    System.out.println("GestionUDPS2C:lectureFichier"+e.toString());
	}
	catch (IOException e) {
	    System.out.println("GestionUDPS2C:lectureFichier"+e.toString());
	}
        }
    
    protected static void main(String args[]) {
	JFrame frame=new JFrame();
	GestionUDPS2C b=new GestionUDPS2C(frame);
    }
}
