package temp;
import java.io.*;
import java.net.*;
import java.util.*;



////////////////////////////////////////////
//
// Ce serveur UDP se bloque sur un receive.
// Quand il recoit un message, il repond en envoyant la date.
//
////////////////////////////////////////////

public class ServeurUDP extends Thread
{
    // Fichier scenario
    protected FileReader fr;
  
 
  // Socket_UDP est le socket de'ecoute du serveur
  protected DatagramSocket Socket_UDP  = null;
  
  // Le prot par defaut est 7545
  public ServeurUDP() throws IOException
    {
      Socket_UDP = new DatagramSocket(7545);
    }
  
  public ServeurUDP(int Un_Port,String frName) throws IOException
    {
      Socket_UDP = new DatagramSocket(Un_Port);
     fr = new FileReader(frName);
    }
  
  // methode run du thread
  public void run()
    {
      int Port               = 0;
      DatagramPacket Message = null;
    
      String La_Date         = null;
      byte[] Tampon          = new byte[256];  // taille des paquets pour initialisee la communication
      //byte[] Tampon1         = new byte[1000];
      
      BufferedReader br = new BufferedReader(fr);
      String c;
      StringTokenizer st;
   


      while ( true )
	{
	  try
	    {
	      // Attendre un message emis par le client
	      Message  = new DatagramPacket(Tampon, Tampon.length);
	      Socket_UDP.receive(Message);
	      
	      // Preparer la reponse (recuperer la date)
	      //La_Date = new Date().toString();
	      //Tampon  = La_Date.getBytes();

	    
	      System.out.println ("Serveur, va emettre : " 
				  +  new String(Tampon)
				  + " \n \t => taille : " 
				  + Tampon.length );
	    
	      // Envoyer la reponse vers le client
	      // dont on recupere l'addresse IP et le port
	      InetAddress Adresse_IP = Message.getAddress();
	      Port                   = Message.getPort();
	      Message                = new DatagramPacket (Tampon , Tampon.length, Adresse_IP, Port);
	      Socket_UDP.send(Message);
  
	      //final DatagramPacket Message1 = new DatagramPacket (Tampon1 , Tampon1.length, Adresse_IP, Port);
	      this.setPriority(MAX_PRIORITY);
	      try {
		  sleep(200); // attendre 200 millisecond avant de commencer a jouer le scenario
	      }
	      catch(InterruptedException e) {
		  System.out.println(e);
	      }

	      long ltime=0;
	      int itime;
	      long timePrec = 0;
	      long timeCurrent;

	      System.out.println("Debut d'emission: " + new Date().toString());

	      while ( (c = br.readLine()) != null ) {
		  st = new StringTokenizer(c);
		 
		  try {
		      //System.out.println("Time: "+ (timeCurrent = (new GregorianCalendar().getTimeInMillis())));
		      sleep(ltime = (Long.valueOf(st.nextToken()).longValue()),itime=(Integer.valueOf(st.nextToken()).intValue()));
		      //System.out.println("en ms: " + ltime + ", en ns: " + itime);
		      //System.out.println("Difference: "+ (timeCurrent-timePrec) );
		      // timePrec = timeCurrent;
		  }
		  catch(InterruptedException e) {
		      System.out.println(e);
		  }
		  try {
		  byte[] tampon2        = new byte[Integer.valueOf(st.nextToken()).intValue()];
		  final DatagramPacket message2 = new DatagramPacket (tampon2 , tampon2.length, Adresse_IP, Port);
		  Socket_UDP.send(message2);
  }
		  catch(NoSuchElementException e) {
		  System.out.println(e);	
		  }

	      }
	      System.out.println("Fin d'emission: " +new Date().toString());

	      br.close();

	      // Definit la tache d'emission des paquets
	      /**TimerTask ipTime = new TimerTask() {
		  public void run() {
		      try {
		      Socket_UDP.send(Message1);
		      	    }
		      catch (IOException e) {
			  e.printStackTrace();
		      }
		  }
	      };

	   
	      while ( (c = br.readLine()) != null ) {
		  st = new StringTokenizer(c);
		  
		      System.out.println("Time: "+ (timeCurrent = (new GregorianCalendar().getTimeInMillis())));
		      try {
		      (new Timer()).schedule(ipTime,ltime = (Long.valueOf(st.nextToken()).longValue()));
		      }
		      catch(IllegalStateException e) {
			  System.out.println(e);
		      }
		      System.out.println("en ms: " + ltime);
		      System.out.println("Difference: "+ (timeCurrent-timePrec) );
		      timePrec = timeCurrent;
	      } // end of while

	      ipTime.cancel();

	      */


	    }
	  catch (IOException e) {
	      e.printStackTrace();
	  }
	} // fin du while
   
      // Socket_UDP.close();
    } // fin de run

}
