package test.model;

/**
 * GenericModelTest : it's a class where we define principal characteristics of a model to test
 * 							These classes permit to test model validity...
 * 
 * @author mladoue
 * @version 0.1, 28/02/03
 */

import java.io.*;


public abstract class GenericModelTest {

	/**
	 *  Test duration in minutes
	 */	
	protected int tpsSimul; 
	
	/**
	*  Specify if we use a graphic mode or not
	*/	
	protected boolean graphic;
	
	/**
	 * Result File ans associated FileWriter
	 */
	protected File resultFile;
	protected FileWriter fichierReq;
	protected String resultFileName;
	
	/**
   	* Method getResultFileName : return the name of the generated scenario file
   	* @return the result fileName
   	*/
    public String getResultFileName()  { return resultFile.getPath();   }
    
    
	/**
	 * Method getTestDuration
	 * @return test duration in mn
	 */
	public int getTestDuration() { return tpsSimul; }
	
	/**
	 * Method getResultFileSize.
	 * @return long
	 * @throws SecurityException
	 */
    public long getResultFileSize() throws SecurityException { return resultFile.length();  }
    
}
