package text;

/**
 * RunUDPClient: Pour lancer le test, cote client, en mode texte.
 * 
 * @author mladoue
 * @version 0.1, 18/12/02
 */

import java.io.*;
import java.net.InetAddress;
import java.net.UnknownHostException;

import traffic.*;

/**
 * 
 * 	Usage:   java  text.RunUDPClient <udp-dest-port> <udp-src-port> <server-name>
 * @author mladoue
 * @version 0.1
 */
public class RunUDPClient {

	public static void main(String[] args) {
		
		// valeurs par defaut.
		int destPort = 5000;  
		int srcPort = 4900;
		String serverName = "kawa";
		
		BufferedReader brInput = new BufferedReader(new InputStreamReader(System.in));
		SimpleUDPClient suc;
		
		if (args.length != 3 && args.length != 0 ) {
      		System.out.println("Usage:   java  text.RunUDPClient <udp-dest-port> <udp-src-port> <server-name>");
      		
		System.out.println("UDP destination port number: ");
	    try {
			destPort = (Integer.decode(brInput.readLine())).intValue();
	    }
	    catch (IOException e) {
		System.out.println("Erreur de lecture de la console.");
		System.exit(0);
	    }
	    System.out.println("UDP source port number: ");
	    try {
			srcPort = (Integer.decode(brInput.readLine())).intValue();
	    }
	    catch (IOException e) {
		System.out.println("Erreur de lecture de la console.");
		System.exit(0);
	    }
	    System.out.println("Server name: ");
	    try {
			serverName = brInput.readLine();
	    }
	    catch (IOException e) {
			System.out.println("Erreur de lecture de la console.");
			System.exit(0);
	    }
	    
	}
	
	else if (args.length == 3 && args.length != 0) {
		try {	
	      	destPort = Integer.parseInt(args[0]);
	    	srcPort = Integer.parseInt(args[1]);
	      	serverName = args[2];
		}
		catch (IllegalArgumentException iae) {
			iae.printStackTrace();
			System.out.println("Arguments aren't valid!");
		}
	} // end else if
		
		//Creation du client UDP
		suc = new SimpleUDPClient( destPort , srcPort, serverName);
		
	try {
	 InetAddress client = InetAddress.getLocalHost();
	 System.out.println("Client created on " + client.getHostName() + ": destination/source port: " + destPort +"/"+ srcPort +", server name: " + serverName +".");
	}
	catch (UnknownHostException uhe) { uhe.printStackTrace(); }
		
	}
}
