package text;

import java.io.*;

import traffic.*;
import traffic.generation.*;

/**
 * RunUDPServer : To run the UDP Server (which is a Thread)<BR>
 * 	Usage:   java  text.RunUDPServer <udp-port> <file-name> <packet-size>
 * @author mladoue
 * @version 0.1 20/12/02
 */

public class RunUDPServer {

	public static void main(String[] args) throws java.io.IOException {
		
		int udpPort = 5000;  //initialisation au cas ou
		String fileName="./JurassicParkLowFormat.scf";
		int packetSize = 1000; // in the case of fixed packet size
		boolean waitConnection = true;
		
		BufferedReader brInput = new BufferedReader(new InputStreamReader(System.in));
    	SimpleUDPServer sus;
    	
     	 if (args.length != 3 && args.length != 0) {
      		System.out.println("Usage:   java  text.RunUDPServer <udp-port> <file-name> <packet-size>");
      		
		System.out.println("UDP port number: ");
	    try {
		udpPort = (Integer.decode(brInput.readLine())).intValue();
	    }
	    catch (IOException e) {
		System.out.println("Erreur de lecture de la console.");
		System.exit(0);
	    }
	    System.out.println("Scenario file name: ");
	    try {
			fileName = brInput.readLine();
	    }
	    catch (IOException e) {
		System.out.println("Erreur de lecture de la console.");
		System.exit(0);
	    }
	    System.out.println("Packet size (in Bytes): ");
	    try {
			packetSize = (Integer.decode(brInput.readLine())).intValue();
	    }
	    catch (IOException e) {
			System.out.println("Erreur de lecture de la console.");
			System.exit(0);
	    }  
	}
	
	else  if (args.length == 3 && args.length != 0) {
	try {	
      udpPort = Integer.parseInt(args[0]);
      fileName = args[1];
      packetSize = Integer.parseInt(args[2]);
	}
	catch (IllegalArgumentException iae) {
		iae.printStackTrace();
		System.out.println("Arguments aren't valid!");
	}
	}

	// Creation du serveur UDP	
	sus = new SimpleUDPServer( udpPort );
	System.out.println("Server created: listened port: " + udpPort +", scenario file: " + fileName +", packet size: " + packetSize +" Bytes.");
	System.out.println("Connextion waited...");
	
	while( waitConnection ) {
		waitConnection = sus.getConnectionState();
	}
	
	System.out.println("Connection created....");
	
	// Une fois que la connexion est cree on joue le scenario
	ScenarioPlayer sp = new ScenarioPlayer(sus,fileName,packetSize);
	
	//ScenarioPlayer sp = new ScenarioPlayer(sus,"./JPLowFormat",1000);
	
	}
	
}







