package traffic;

/**
 * ClasseService : definit la classe a laquelle appartient le paquet
 *
 * @author maria ladoue
 * @version 0.1, 31/07/02 
 */

import java.net.*;
import java.net.DatagramSocketImpl;
import java.lang.Integer;


public class ClasseService extends DatagramSocketImpl implements SocketOptions {

    DatagramSocket ds;
   
    public static int IP_TOS = 0; // pas encore implementer

    public ClasseService () throws SocketException {
		ds = new DatagramSocket();
		setOption(IP_TOS,new Integer(0));
    }
    
    public ClasseService (DatagramSocket unDS,int uneValeurCoS) throws SocketException {
        ds = unDS;
		setOption(IP_TOS,new Integer(uneValeurCoS));
    }  

    // Definition de quelques methodes propres a la classe

    // Pour obtenir la valeur sous forme d'un entier
    public int getClasseService() throws SocketException {
		return ((Integer)this.getOption(0)).intValue(); 
    }
    
    public void setDS(DatagramSocket unDS) {
		ds = unDS;
    }
    
    /**
     * Renvoit le socket par lequel on envoie des datagrammes
     * @return le socket
     */
    public DatagramSocket getDS() {
	return ds;
    }
    

    // methodes heritees de l'interface SocketOptions
    public void setOption(int optID, Object value) throws SocketException {
	Object o = value;
	if (o instanceof Integer) {
	    if (optID == IP_TOS) { 
		ds.setTrafficClass( ((Integer)o).intValue() );
	    }
	    else {  System.out.println("this parameter coudn't be retrieve");}
	}
	else { System.out.println("value must be an int");}
    }
    
    public Object getOption(int optID) throws SocketException {
	int i;
	Object o;
       	if (optID == IP_TOS) {
	    try {
	    i = ds.getTrafficClass();
	    o = new Integer(i);
	    return o;
	    }
	    catch (SocketException e) {
		System.out.println("there is an error obtaining the traffic class or type-of-service value");	
		return new Boolean("false");
	    }
	}
	else { 
	    o = new Boolean("false");
	    return o;
	}
    }
    
    

    // methodes heritees de la classe DatagramSocketImpl

    protected void bind(int lport, InetAddress laddr) {}
    protected void close() {}
    protected void create() {}
    protected int getTimeToLive() { return 0; }
    protected byte getTTL() { return 0; }
    protected void join(InetAddress inetaddr) {}
    protected void joinGroup(SocketAddress mcastaddr, NetworkInterface netIf) {}
    protected void leave(InetAddress inetaddr) {}
    protected void leaveGroup(SocketAddress mcastaddr, NetworkInterface netIf) {}
    protected int peek(InetAddress i) { return 0; }
    protected int peekData(DatagramPacket p) { return 0; }
    protected void receive(DatagramPacket p) {}
    protected void send(DatagramPacket p) {}
    protected void setTimeToLive(int ttl) {}
    protected void setTTL(byte ttl) {}
  
   /**
    * Methode: Main pour tester la classe
    */

    public static void main (String[] args) throws SocketException {
	
	ClasseService uneCS = new ClasseService();
	System.out.println( uneCS.getOption(0).toString() );
	uneCS.setOption(0,new Integer(2));
	System.out.println( uneCS.getOption(0).toString() );

	
    }// fin du main
    
} 

