package traffic.distributed;

/**
 * HostInformations : Interface for exporting services for UDP clients/servers
 * 	     objet distant = instance d'une classe implementant l'interface "Remote"
 * 
 * @author mladoue
 * @version 0.2, 12/02/03
 */

import java.io.IOException;
import java.rmi.*;
import java.util.SortedSet;

public interface HostInformations extends Remote {

	public static String name = "HostInformations";
	
	// Cote server
    public String[] getServerList() throws RemoteException;
    public String[] getJavaCmdServerList() throws RemoteException;
    public int[] getServerPortList() throws RemoteException;
	public String getServerNameForClient(String clientName, int port) throws IOException, RemoteException;
	public int getServerPortForClient(String clientName, int port) throws IOException, RemoteException;
	public int getUDPServerPort(String serverName) throws IOException, RemoteException,IOException;
	public String getServerIPAddress(String serverName, int port) throws RemoteException;
 
    // Cote client
    public int getUDPClientPort(String clientName) throws RemoteException, NumberFormatException, IOException;
	public int getClientCOS(String clientName, int port) throws RemoteException,IOException, NumberFormatException;
	public boolean isClientIPv4(String clientName, int port) throws RemoteException,IOException;
	public String[] getScenarioFilesList(String serverName, int port)  throws RemoteException;
	public int getScenarioFileNumber(String serverName, int port) throws RemoteException;
	public SortedSet getScenarioFiles(String serverName, int port) throws RemoteException;
	public String[] getClientsList(String serverName, int port)  throws RemoteException;
	public String[] getClientsList()  throws RemoteException;
	public String[] getJavaCmdClientsList()  throws RemoteException;
	public int[] getClientsPortList()  throws RemoteException;
	public int[] getClientsPortList(String serverName, int port)  throws RemoteException;
    
    public String getAccessTypeForClient(String clientName, int port)throws RemoteException;
    public String getAccessTypeForServer(String serverName, int port)throws RemoteException;

	// retourne 1/0 si ca c'est bien passe ou non
	public byte[] transferScenario(String fileName) throws RemoteException, java.io.IOException;
    

}
