package traffic.distributed;

/**
 * RemoteUDPClient : Doit etre lancee sur la machine cliente
 * 
 * @author mladoue
 * @version 0.1 17/02/03
 */

import traffic.SimpleUDPClient;
import utils.RegistryListor;


public class RemoteUDPClient {
	
    public static void main(String[] args) {
    	
	String serviceName;
	boolean serverAvailable = false;
	
    // Usage: traffic.distributed.RemoteUDPClient  <rmi-server-name> <rmi-port> [service-name]
	if(args.length == 0 ) {
           System.err.println("Usage: java traffic.distributed.RemoteUDPClient <rmi-server-name> <rmi-port> [service-name]");
           return;
	}
			
	if (args.length > 2) { serviceName = args[2]; } 
	else { serviceName = HostInformations.name;   }
	
	while(!serverAvailable) {
            if( (new RegistryListor(args[0], Integer.parseInt(args[1]))).isServiceAvailable("//"+args[0]+":"+args[1]+"/"+serviceName) || 
                (new RegistryListor(args[0], Integer.parseInt(args[1]))).isServiceAvailable("rmi://"+args[0]+":"+args[1]+"/"+serviceName) ) { serverAvailable = true; }
	}
	
	HostInformationsClient hic = new HostInformationsClient(args[0],Integer.parseInt(args[1]),serviceName,0);
	
	SimpleUDPClient suc = new traffic.SimpleUDPClient(hic.getUDPServerPort(),
                                                  hic.getUDPClientPort(),
                                                  hic.getServerName(),  hic.isClientIPv4());
    }
}

