package traffic.distributed;

import java.io.*;

/*
 * This is the base class in charge of manging output coming from remote
 * objects. 
 * For the moment, the class is quite basic since it does not support
 * outputStream (ie. send strings to remote object in response to a question).
 */
public class StreamGobbler extends Thread
{
	InputStream is;
	String type;

		// Object in charge of "displaying" the received streams.
	OutputDisplayerI od;

/*	StreamGobbler(InputStream is, String type) {
		this(is, type, null);
	}
   */     
	
	StreamGobbler(InputStream is, String type, OutputDisplayerI od) {
		this.is = is;
		this.type = type;
		this.od = od;
	}
       
	public void run() {
		try {
			InputStreamReader isr = new InputStreamReader(is);
			BufferedReader br = new BufferedReader(isr);
			String line=null;
			while ( (line = br.readLine()) != null)
			{
				od.display(line, type);
			}
		} 
		catch (IOException ioe) {
			ioe.printStackTrace();  
		}
	}
}