package traffic.generation;

import java.io.FileNotFoundException;
import java.net.InetAddress;
import java.net.SocketException;
import java.net.UnknownHostException;

import traffic.SimpleUDPServer;
import traffic.distributed.*;
import utils.RegistryListor;

/**
 * RemoteUDPServer : Doit etre lance sur les machines serveurs
 * 
 * @author mladoue
 * @version  0.1, 12/02/03 
 */

public class RemoteUDPServer {

	public static void main(String[] args) throws FileNotFoundException {
		
	String serviceName = HostInformations.name;
	String clientName="",serverName="";
	int clientPort=0, serverPort=0, packetSize = 0;
	boolean waitConnection = true;
	boolean serverAvailable = false;
	
	SimpleUDPServer sus;
	
	// Usage: traffic.generation.RemoteUDPServer  <rmi-server-name> <rmi-port> <file-name> [packet-size]
	if(args.length < 3 ) {
		System.err.println("Usage: java traffic.distributed.RemoteUDPServer <rmi-server-name> <rmi-port> <file-name> [packet-size]");
		return;
	}
	
	while(!serverAvailable) {
            if( (new RegistryListor(args[0], Integer.parseInt(args[1]))).isServiceAvailable("//"+args[0]+":"+args[1]+"/"+HostInformations.name) ||
                (new RegistryListor(args[0], Integer.parseInt(args[1]))).isServiceAvailable("rmi://"+args[0]+":"+args[1]+"/"+HostInformations.name)) { serverAvailable = true; }
                //else { wait(60); } // sinon on attend 60 secondes avant de redemander
        }
	
	HostInformationsClient hic = new HostInformationsClient( args[0], Integer.parseInt(args[1]), serviceName,1);
	
	// On recupere la valeurs des differents arguments passes en parametre
	String fileName= args[2];
	
	if (args.length == 4) {
		packetSize =  Integer.parseInt(args[3]);  
	}
	// On recupere les differentes infos (de HostInformations) dont on a besoin
	 serverPort = hic.getUDPServerPort();	 
	 	 
	try {	
		sus = new SimpleUDPServer(serverPort);
		
		try {
			InetAddress server = InetAddress.getLocalHost();
			System.out.println("Server created on: " +  server.getHostName() + ": listening port: " + serverPort + ".");
		}
		catch (UnknownHostException uhe) { uhe.printStackTrace(); }
	
	while(waitConnection) {
		waitConnection = sus.getConnectionState();
	}
	// Une fois que la connexion est cree on joue le scenario
	
	ScenarioPlayer sp = new ScenarioPlayer(sus, fileName, packetSize);
	
	}
	catch( SocketException se) { se.printStackTrace(); }
	catch( FileNotFoundException fnfe) { System.out.println(" The file:  " + fileName +" cannot be found!"); }		
		
	}
}
