package utils;


/**
 * FileAttenteSynchronisee :
 * 
 * @author 
 * @version 0.1, 04/07/02
 */

import java.util.*;

/**
 * Permet de grer une file d'attente de String.
 * Gre les accs concurrents  la file.
 */

public class FileAttenteSynchronisee {
    //La file de String
    Vector file;
    
    /**
     * Construction de la file d'attente.
     */
    public FileAttenteSynchronisee() {
	file = new Vector();
    }
    
    /**
     * Ajoute un String dans la file.
     */
    public void ajouter(String message){
	message=this.action(1,message);
    }
    
    /**
     * Ajoute un String en tte de la file.
     */
    public void ajouterEnTete(String message){
	message=this.action(3,message);
    }
    
    /**
     * Retire un String de la file.
     * <br><b><u>ATTENTION</u></b>: il faut examiner si la file est vide avant d'appeler cette mthode.
     * Si la file est vide, une exception FileVideException est leve.
     */
    public String retirer(){
	if (this.vide())
	    throw new FileVideException("La file est vide: impossible de retirer un lment");
	String message="";
	return (this.action(0,message));
    }
    
    /**
     * Indique si la file est vide ou pas.
     * @return un boolen
     */
    public boolean vide(){
	String s="";
	s=this.action(2,s);
	if (s.equals("o")) { return true; }
	else { return false; }
    }
 
    /**
     * 0 <=> retire un String de la file
     * 1 <=> ajoute un String dans la file
     * 2 <=> examine si la file est vide
     * 3 <=> ajoute un String en tte de la file
     */
    protected synchronized String action(int i, String message){
	
	String s = "";
	try {
	    switch (i){
	    case 0: 
		s=(String)(file.remove(0));
		break;
	    case 1:
		file.add(message);
		break;
	    case 2:
		if (file.isEmpty()) {s="o";} else {s="n";}
		break;
	    case 3:
		file.add(0,message);
		break;
	    }
	}
	catch(ArrayIndexOutOfBoundsException e) {
	    System.out.println("FileAttenteSynchronisee: action =>" + e.toString());
	}
	    return s;
    }
    
 /**
  * Methode: Main pour tester la classe courante
  */
    
  
    public static void main(String args[]) {
	FileAttenteSynchronisee file = new FileAttenteSynchronisee();
	file.ajouter("Bonjour");
	file.ajouter("Aurevoir");
	file.ajouterEnTete("Salut");
	System.out.println(file.retirer());
	System.out.println(file.retirer());
	System.out.println(file.retirer());
        }
}
