package utils;

/**
 * FileLineCounter
 * 
 * @author mladoue
 * @version 0.1
 */

 import java.io.*;
        
   public class FileLineCounter {
              
			/**
			 * Method countLines.  Count the number of lines in the specified file, and 
			 * print the number to standard output.  If an error occurs while processing the file,
			 *  print an error message instead. Two try...catch statements are used
			 *  so I can give a different error message in each case.
			 * @param fileName
			 * @return int
			 */
   			  public static int countLines(String fileName) {
                  
              BufferedReader in = null;;  // A stream for reading from the file.
              int lineCount = 0;  // Number of lines in the file.
              
              try {
              	 
                  in = new BufferedReader( new FileReader(fileName) );
              }
              catch (Exception e) {
                  System.out.println("Error.  Can't open file.");
                  System.exit(1);
              }
              
              try {
                 while (in.readLine() != null) {
                        // Read the next line and count it.
                    //in.read();
                    lineCount++;
                 }
              }
              catch (Exception e) {
                 System.out.println("Error.   Problem with reading from file.");
                 System.exit(1);
              }
             
           return lineCount;
           }  // end countLines()     
           
            public static boolean sameLineNumber(String f1Name,String f2Name) {
            	if ( countLines(f1Name) == countLines(f2Name) ) {
            		return true;
            	}
            	else {
            		return false;
            	}
            	
            }
           
      
	public static void main(String[] args) {
		
		    // The main() routine simply gets the file names from the
                 // command line and calls the countLines() routine to process
                 // each name.  Since any errors are handled in the countLines()
                 // routine, the main program will continue after an error occurs
                 // while trying to process one of the files.
              
              if (args.length == 0) {
                     // This program must have at least one command-line argument to work with.
                  System.out.println("Usage:   java  util.FileLineCounter <file-names>");
                  return;
              }
              
              for (int i = 0; i < args.length; i++) {
                 System.out.print(args[i] + ": ");
                 System.out.println(countLines(args[i]));
              }
		
	}
}
