/**
 * MyNumberFormat To formate files
 *
 * @author maria ladoue
 * @version 0.1, 08/10/02 
 */

package utils;

import java.io.*;
import java.util.*;
import java.text.*;


public class MyNumberFormat {
	
	
	//	en s avec une precision a la nano-seconde
	 public static DecimalFormat myTimeFormatter = new DecimalFormat("0000.000000");
	 // en ms avec une precision a la nano-seconde
	 public static DecimalFormat myIAFormatter = new DecimalFormat("000.000");
	 public static DecimalFormat myDebitFormatter = new DecimalFormat("000.00");
	 // defined for packet size formatting in Bytes: max 9000 bytes (jumbo frames)
	 public static DecimalFormat mySizeFormatter = new DecimalFormat("##0000");
	// Formet a percentage
	public static DecimalFormat myPercentFormatter = new DecimalFormat("#0.00");

	public static String customDateFormat() {
		DateFormat df = DateFormat.getTimeInstance(DateFormat.SHORT);
		String output = df.format(new Date());
		return output;
	}

	public static String customNumberFormat(String pattern, double value) {
		DecimalFormat myFormatter = new DecimalFormat(pattern);
		String output = myFormatter.format(value);
		//System.out.println(value + "  " + pattern + "  " + output);
		return output;
	}

	public static String doubleFormat(double value)
		throws NullPointerException, IllegalArgumentException {
		DecimalFormat myFormatter = new DecimalFormat("##0000.000000");
		// Precision a la nano-seconde
		String output = myFormatter.format(value);
		return output;
	}

	public static String intFormat(int value)
		throws NullPointerException, IllegalArgumentException {
		DecimalFormat myFormatter = new DecimalFormat("0000");
		// Precision a la nano-seconde
		//DecimalFormat myFormatter = new DecimalFormat("0.000000"); // Precision a la micro-seconde
		String output = myFormatter.format(value);
		return output;
	}

	public static String scenarioTextFormat(double value) {
		DecimalFormat myFormatter = new DecimalFormat("#.######E0");
		String output = myFormatter.format(value);
		return output;
	}


/**
 *  This permit to transform a file content into a String.
 * 		Used to display configuration file content
 * @param f
 * @return String
 * @throws IOException
 */
public static String configurationFileToString(File f) throws IOException {
	
		String ans = new String(), c ="";
		FileReader fr = new FileReader(f);
		BufferedReader br = new BufferedReader(fr);

		try {
			while ( (c = br.readLine()) != null ) {			
				ans = ans.concat(""+ c +"\n");
			}
		}
		catch (IOException ioe) {
				ioe.printStackTrace();
				System.out.println(ioe);
			}		
		fr.close();
	return ans;
}

	/** 
	 * @param fileName  scenario file name (without the extension) which will be formated 
	 * @param resultName formated file name
	 * @throws IOException
	 * @throws IllegalArgumentException
	 * @deprecated
	 */
	public static void timeFormatage(String fileName, String resultName) throws IOException, IllegalArgumentException {
	
		if (FileTest.isExistent(fileName)) {
		
		FileWriter fw = new FileWriter(resultName) ;
		FileReader fr = new FileReader(fileName);
		
		BufferedReader br = new BufferedReader(fr);
		BufferedWriter bw = new BufferedWriter(fw);
		
		String c ="";

		try {
		while ((c = br.readLine()) != null) {
			try {
				bw.write(doubleFormat(Double.valueOf(c).doubleValue()).toString().replace('.','\t'));
				bw.newLine();
			} 
			catch (NumberFormatException e) {
				e.printStackTrace();
			}
		}
		}
		catch (IOException ioe) {
				ioe.printStackTrace();
				System.out.println(ioe);
			}
			
		bw.flush();
		fr.close();
		fw.close();
		
		if ( FileLineCounter.sameLineNumber( fileName, resultName + ".scf") ) {
				System.out.println("File formated!");
		}
		 else {
				System.out.println( "File malformated! \nOriginal File: "
						+ FileLineCounter.countLines(fileName) + " lines \t Formated File: "
						+ FileLineCounter.countLines(resultName+ ".scf") + " lines");
			}
		} 
		 else {
			throw new FileNotFoundException(fileName + " doesn't exist!");
		}	
	}

	/**
	 * To format  scenario files
	 *	return a file formated as follow:<BR>
     * 	<i>IPTime  (millisecond part)</i> \t <i>IPTime (nanosecond part)</i> \t<i>size in Bytes</i><BR>
	 *
	 * @param frName file name which has to be formated
	 * @param fwName formated file name
	 * @throws IOException
	 */

	public static void timeSizeFormatage( String frName, String fwName) throws  IOException {
	
		if ( FileTest.isExistent("./" + frName ) ) {
			
			FileWriter fw = new FileWriter(fwName+ ".scf") ;
			FileReader fr = new FileReader(frName);

			BufferedReader br = new BufferedReader(fr);
			BufferedWriter bw = new BufferedWriter(fw);

			String c = "",tmp;
		
			double value = 0;
			int val = 0;
			int lineNumber = FileLineCounter.countLines(frName);
			int k = 0;
			StringTokenizer st;
			
			try {
				while ((c = br.readLine()) != null) {
					try {
						st = new StringTokenizer(c);
						k++;
					
						String s1 = st.nextToken();
						if (s1 != null) {
						value = Double.valueOf(s1).doubleValue();  // IP time
						} 
						else {
							System.out.println(
								" IPTime value: " + value + " on line " + k);
								s1 = "0";
						}
						//value = Double.valueOf(st.nextToken("\t")).doubleValue();
						String s2 = st.nextToken();
						if (s2 != null) {
							val = Integer.valueOf(s2).intValue();  // taille des paquets

						} else {
							System.out.println(
								" Packet size:  " + val + " on line " + k);
							s2 = "0";
						}
						tmp = doubleFormat(value).toString().replace('.', '\t') + "\t" + intFormat(val).toString();
						//tmp = doubleFormat(Double.valueOf(st.nextToken()).doubleValue()).toString().replace('.','\t') + "\t" +  intFormat(Integer.valueOf(st.nextToken()).intValue()).toString();
							
						bw.write(tmp);
						bw.newLine();
					
					}// end try
					catch (NumberFormatException e) {
						System.out.println( e + ", valeur: " + value
								+ ", val: "
								+ val
								+ ", on line: "
								+ k);
					} catch (NoSuchElementException nsee) {
						nsee.printStackTrace();
					} 
				} // end while
			} 
			catch (IOException ioe) {
				System.out.println(ioe);
			}
		
			bw.flush();	
			fr.close();
			fw.close();
			
			if ( FileLineCounter.sameLineNumber(frName, fwName+ ".scf") ) {
				//System.out.println("File formated!");
				MessageManager.informationMessage("File formated as: " + new File(fwName).getCanonicalPath(), false);
				new File(frName).delete(); // on efface le fichier intermediaire dont on n'a plus besoin.
				
			} else {
				System.out.println( "File malformated! \nOriginal File: "	+ lineNumber + " lines \t Formated File: "
						+ FileLineCounter.countLines(fwName) + " lines");
			}
		}
	 else { throw new FileNotFoundException(frName + " doesn't exist!");	}
	}


	/**
	 * Method getPacketNumberHeaderSize.
	 * @param lineNumber
	 * @return short
	 */
	public static short getPacketNumberHeaderSize(int lineNumber) {
		short i = 1;
		while ( (double)(lineNumber/(Math.pow(10,i))) > 1d ) {
			 i++;
		}
		return i;
	}


	/**
	 * Methode: Main pour tester la classe
	 */

	public static void main(String[] args) {
		//System.out.println( customDateFormat() );
		//System.out.println( doubleFormat(12.475239444393) );
		//System.out.println( scenarioTextFormat(024.0004752394483814393) );
		//try {
			//timeFormatage(new FileReader("MMPPNGene"),"MMPPNGeneFormat");
			//timeSizeFormatage("JPLow","JPLowFormat");
			//timeSizeFormatage(FileTest.formated("JPLow","JPLowModified"),"JPLowFormat");
			//timeSizeFormatage("JPLow", "JPLowFormat");
		//} catch (FileNotFoundException fe) {
		//	System.out.println(fe);
		//} catch (IOException e) {
		//	System.out.println(e);
	//	}
		//GregorianCalendar gc = new GregorianCalendar();
		//System.out.println("Time en ms: "+ (new GregorianCalendar().getTimeInMillis()));
		
		
		/**
		System.out.println( getPacketNumberHeaderSize(12345) );
		
		String decF = "0";
			for (int k=1;k<5;k++) {
				decF = decF.concat("0");
				System.out.println(decF);
			}
			System.out.println(decF);
		
		try {
		File f = new File("/0/mistral2/mladoue/conf4.conf");
		System.out.println( configurationFileToString(f) );
		}
		catch (IOException e) {
		e.printStackTrace();	
		}
		*/
		
		String[] ans = new String[1];
		ans[0] = "true";
		if(Boolean.valueOf(ans[0]).booleanValue()) { 
		System.out.println(Boolean.valueOf(ans[0]));
		}
	}

}
