package utils;

import java.util.Vector;

import utils.definitions.MyExceptionDefinitions;

/**
 * @author mladoue

 */
public class MyTableOperation {

	
	public static int[][] circularPermutation(int[] idx, int[][] array) {
		
		if ( TestParameters.has2DIntTableSameColumnsNumber(array) && idx.length == array.length) {
	
		int[][] newData = new int[array.length][array[0].length];  
		int[][] data =array;  
				
		int oldColumnNb =0;
			
		for ( int i=0; i<array.length; i++) {
			oldColumnNb = idx[i];
			for( int k=0;k<array[0].length;k++ ) {
				if( oldColumnNb < array[0].length ) {	
					newData[i][k] = data[i][ oldColumnNb ];
					oldColumnNb++;
				}
				else {
					oldColumnNb = 0;
					newData[i][k] = data[i][ oldColumnNb ];
					oldColumnNb++;
				}
			}
		
			}
				return newData;
		}
		else { throw new IllegalArgumentException(""); }
	}

	public static void print2DArray( int valueNb, int[][] array ) throws IllegalArgumentException { 
		String ans = "";
	
	if( TestParameters.has2DIntTableSameColumnsNumber(array)  ) {
	
		if ( valueNb>0 && array[0].length > (valueNb-1)) {
			for (int i=0; i< array.length;i++ ) {
				for ( int j=0;j<valueNb;j++) {
					ans += new String(array[i][j] + "\t");
				}
				System.out.println("Value 0 to " +  (valueNb-1) + " for source "+  i +" : "  + ans);
				ans = "";
			}
		}
			else { 
				System.out.println("WARNING: Lenght of this array is: " + array[0].length + " instead of: " + valueNb);
				for (int i=0; i< array.length;i++ ) {
					for ( int j=0;j<valueNb;j++) {
						ans += new String(array[i][j] + "\t");
					}
					System.out.println("The first " + array[0].length + " values are: "  + ans);
					ans = "";
				}
			}
	}
	else {  throw new IllegalArgumentException("You must have the same column number for each line"); }
	}
	
	public static void print2DArrayPart( int from, int to, int[][] array ) throws IllegalArgumentException { 
		String ans = "";

	if( TestParameters.has2DIntTableSameColumnsNumber(array)  ) {
		if ( from>=0 && array[0].length > to && from<=to ) {
			for (int i=0; i< array.length;i++ ) {
				for ( int j=from;j<to;j++) {
					ans += new String(array[i][j] + "\t");
				}
				System.out.println("Value " + from+" to " + to + " for source "+  i +" : "  + ans);
				ans = "";
			}
		}
			else { 
				System.out.println("WARNING: Lenght of this array is: " + array[0].length + " instead of: " + (to+1));
				for (int i=0; i< array.length;i++ ) {
					for ( int j=from;j<array[0].length;j++) {
						ans += new String(array[i][j] + "\t");
					}
					System.out.println("The last " + (array[0].length-from) + " values are: "  + ans);
					ans = "";
				}
			}
	}
	else {  throw new IllegalArgumentException("You must have the same column number for each line"); }
	}


	public static void printArray( int valueNb, int[] array )  { 
		String ans = "";

		if ( valueNb>0 && array.length >= valueNb) {
			for (int i=0;i<valueNb;i++) {
				ans += new String(array[i] + "\t");
			}
			System.out.println("Value 0 to " +  (valueNb-1) + " : "  + ans);
		}
		else { 
			for (int i=0;i<array.length;i++) {
					ans += new String(array[i] + "\t");
			}
			System.out.println("WARNING: Lenght of this array is: " + array.length + " instead of: " + valueNb);
			System.out.println("The first " + (array.length-1) + " values are: "  + ans);
		}
	}

	public static void printArrayPart( int from, int to, int[] array )  { 
		String ans = "";

		if ( from>=0 && array.length > to && from<=to ) {
			for (int i=from;i<to;i++) {
				ans += new String(array[i] + "\t");
			}
			System.out.println("Value " + from + " to " + to + " : "  + ans);
		}
		else { 
			for (int i=from;i<array.length;i++) {
					ans += new String(array[i] + "\t");
			}
			System.out.println("WARNING: Lenght of this array is: " + array.length + " instead of: " + (to+1) );
			System.out.println("The last " + (array.length-from) + " values are: "  + ans);
		}
	}

	/**
	 * Method transformSTS. to transform a String[] in a String to visualize results
	 * @param st
	 * @return String
	 */
	public static String transformST2S(String[] st) {
	
	String ans = "";
	for (int i=0;i<st.length-1;i++) {	
	ans = ans.concat(st[i] + " ");
	}
	ans = ans.concat(st[st.length-1]);
	return ans;
	}

	/**
	 * Method transformSTDT. to transform double[] parameters in String[]
	 * @param paramsD
	 * @return String[]
	 */
	public static String[] transformDT2ST(double[] paramsD) {
		String[] ans = new String[paramsD.length];
	
		for (int i=0;i<paramsD.length;i++) {
		ans[i] = Double.toString(paramsD[i]);	
		}
		return ans;
	}


	/**
	 * Method transformSTDT. to transform String[] parameters in double[]
	 * @param paramsS
	 * @return double[]
	 */
	public static double[] transformST2DT(String[] paramsS) {
		double[] ans = new double[paramsS.length];
	
		for (int i=0;i<paramsS.length;i++) {
		ans[i] = Double.parseDouble(paramsS[i]);	
		}
		return ans;
	}


	/**
	 * Method transformV2IT: to transform Vector parameter in int[]
	 * 								WARNING: works only if vector values are "int compatible"
	 * @param v
	 * @return int[]
	 */
	public static int[] transformV2IT(Vector v) {
		int[] ans = new int[v.size()];
		for (int i=0;i<v.size();i++) {
			ans[i] = ((Integer)v.elementAt(i)).intValue();
		}
		return ans;
	}

	/**
	 * Method transformV2DT: to transform Vector parameter in double[]
	 * 								WARNING: works only if vector values are "double compatible"
	 * @param v
	 * @return double[]
	 */
	public static double[] transformV2DT(Vector v) {
		double[] ans = new double[v.size()];
		for (int i=0;i<v.size();i++) {
			ans[i] = ((Double)v.elementAt(i)).doubleValue();
		}
		return ans;
	}

	/**
	 * Method transformDTT2DT : to extract a double[] from a double[][]
	 * @param param
	 * @param tableNumber
	 * @return
	 */
	public static double[] transformDTT2DT(double[][] param, int tableNumber) {
		int tableN = param.length;
		int tableSize = param[0].length;
		double[] ans = new double[tableSize];
	
		if ( tableNumber < tableN ) {
			 for (int i=0;i<tableSize;i++) {
				ans[i] = param[tableNumber][i];
			}
			return ans;
		}	
		else { throw MyExceptionDefinitions.DEFAULT_ERROR; }
	}

	/**
	 *  Method transformIT2DT : to transform an int[] into a double[]
	 * @param param
	 * @return
	 */
	public static  double[] transformIT2DT(int[] param) {
		double[] ans = new double[param.length];
		for (int i=0;i<param.length;i++) {
			ans[i] = (double)param[i];
		}
		return ans;
	}

	/**
	 *  Method transformDT2IT : to transform an double[] into a int[] 
	 * @param param
	 * @return
	 */
	public static  int[] transformDT2IT(double[] param) {
		int[] ans = new int[param.length];
		for (int i=0;i<param.length;i++) {
			ans[i] = (int)Math.round(param[i]);
		}
		return ans;
	}


}
