package utils;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;


import statistic.distribution.GenericDistribution;

/**
 * ObjectConstructor used for graphics.listener.ModelGeneratorConstructor
 * 
 * @author mladoue
 * @version
 */
public class ObjectConstructor {

	/**
	 * To create an object with Parameter 
	 * @param constructor
	 * @param arguments
	 * @return Object
	 */
	public static Object createObject(Constructor constructor, Object[] arguments) {
               //System.out.println ("Constructor: " + constructor.toString());	// DEBUG
				//System.out.println ("Arguments: " + arguments[0].toString()  + " , " + arguments[1].toString());	// DEBUG
		
               Object object = null;

               try {
                 object = constructor.newInstance( arguments );
               // System.out.println ("Object: " + object.toString());  // DEBUG
                 return object;
               }
                catch (InstantiationException ie) {
                   System.out.println( "ObjectConstructor.createObject : InstantiationException : "  + ie.getCause() );
               }
                catch (IllegalAccessException iace) {
                   System.out.println( "ObjectConstructor.createObject : IllegalAccessException : "  + iace.getCause() );
               }
                catch (IllegalArgumentException iae) {
                   System.out.println( "ObjectConstructor.createObject : IllegalArgumentException : "  + iae.getCause() );    
               } 
               catch ( InvocationTargetException ite ) {
                   System.out.println("ObjectConstructor.createObject : InvocationTargetException : "  + ite.getCause());
               }
               return object;
            }
            
            
	/**
	 * To create an object of type GenericDistribution
	 * @param distributionName : the name of the distribution
	 * @param params : distribution parameters
	 * @return GenericDistribution
	 */
	public static GenericDistribution createDistribution(String distributionName, double[] params) {
		GenericDistribution gd;
		
		//System.out.println ("Distribution: " + distributionName);  // DEBUG
		//System.out.println ("Distribution parameters: " + params[0]);  // DEBUG
		
		try {
			gd = (GenericDistribution)Class.forName("statistic.distribution." + distributionName + "Distribution").newInstance();
			gd.setParams(params);
			return gd;
		}
		catch (IllegalAccessException iae) {  System.out.println(iae); 	}
	
		catch(InstantiationException ie) { 
			System.out.println("ObjectConstructor.createDistribution : the initialization provoked by this methode fails => Codec Name : " + distributionName + " "  + ie);
		 }
		catch (ClassNotFoundException cnfe) { 
			System.out.println("ObjectConstructor.createDistribution : The class cannot be located => Codec Name : " + distributionName + " "  + cnfe);
		}
	
		return null;
	}


}
