package utils;

/**
 * SpecificObjectCreation  Class creee uniquement pour permettre de faire des changements de nom bete et mechant
 * 
 * @author mladoue
 * @version 0.2 14/01/03
 */


import java.util.regex.PatternSyntaxException;


import multimedia.codec.*;
import multimedia.*;
import graphics2.panel.client.*;
import graphics2.panel.client.model.*;

public class SpecificObjectCreation implements  AudioCodecExample,VideoCodecExample,VideoExample {


	public static GenericModelPanel createModelGenericPanel( String modelName, InterneModelPanel imp) {
		GenericModelPanel mgp;
	
	if (modelName.equals("OnOff")) {
	 	mgp = new OnOffModelPanel(imp, "On-Off Model features");	
	 }
	 else if (modelName.equals("MMPP2")) {
	 mgp = new MMPP2ModelPanel(imp);	
	 }
	 else if (modelName.equals("MMPPN")) {
	 mgp = new MMPPNModelPanel(imp);	
	 }
	 else if (modelName.equals("MGInf")) {
	 	mgp = new MGInfModelPanel(imp);
	 }
	 else if ( modelName.equals("MGInfComplex")) {
	 	int[] panelNb = {2,1,1,2};
	 	mgp = new MGInfComplexModelPanel(imp,panelNb);
	 }
	 else if (modelName.equals("OnOffHeterogeneousAggregatedFlow")) {
	 	mgp = new OnOffHeterogeneousAggregatedFlowModelPanel(imp);
	 }
	 else if ( modelName.equals("MGInfComplexAggregatedFlow") ) {
		 mgp = new MGInfComplexAggregatedFlowModelPanel(imp);
	  }
	 else {
		throw new IllegalArgumentException("SpecificObjectCreation.createModelGenericPanel: The model: " + modelName + " doesn't exist!");
	 }
	
	return mgp;	
	}
	
/**
 *Methode implementer car pb pour generer cette objet via la "reflection"
 * 			ATTENTION ca n'est pas optimum
 * @param classCodecName
 * @return CodecAV
 */
public static CodecAV createCodecExample(String classCodecName) {
		
		CodecAV codec;
		
 		if (classCodecName.equals("G711")) {
     		codec = G711;
   		}
   		else if(classCodecName.equals("G726")) {
   			codec = G726;
   		}
   		else if(classCodecName.equals("G728")) {
   			codec = G728;
   		}
   		else if(classCodecName.equals("G729")) {
   			codec = G729;
   		}
   		else if(classCodecName.equals("G723.1")) {
   			codec = multimedia.codec.AudioCodecExample.G723_1;
   		}
   		else	if (classCodecName.equals("MJPEG")) {
     		codec = MJPEG;
   		}
   		else	if (classCodecName.equals("MPEG")) {
     		codec = MPEG;
   		}
   		else	if (classCodecName.equals("MPEG4")) {
     		codec = MPEG4;
   		}
   		else	if (classCodecName.equals("H261")) {
     		codec = multimedia.codec.VideoCodecExample.H261;
   		}
   		else {
   			throw new IllegalArgumentException("This codec: " + classCodecName + " is unknown!");
   		}

   		return codec;
} 


/**
 * @param cvn : it has to be form as: "Jurassic Park (Low Quality)"
 * @return
 */
public static VideoDefinition createVideoExample(String cvn) {
	
	VideoDefinition vd;
	
	if (cvn.equals("Jurassic Park (Low Quality)")) {
		vd = JurassicParkLow;
	}
	else if(cvn.equals("None")) {
		vd = new VideoDefinition();
	}
	else if (cvn.equals("Jurassic Park (Medium Quality)")) {
		vd = JurassicParkMedium;	
	}
	else if(cvn.equals("Jurassic Park (High Quality)")) {
		vd = JurassicParkHigh;
	}
	else if (cvn.equals("Bean (Medium Quality)")) {
		vd = BeanMedium;	
	}
	else if (cvn.equals("Bean (Low Quality)")) {
		vd = BeanLow;	
	}
	else if(cvn.equals("Bean (High Quality)")) {
		vd = BeanHigh;
	}
	/**
	else if(cvn.equals("Aladdin (Low Quality)")) {
		vd = AladdinLow;
	}
	else if(cvn.equals("Aladdin (Medium Quality)")) {
		vd = AladdinMedium;
	}
	else if(cvn.equals("Aladdin (High Quality)")) {
		vd = HighMedium;
	}
	*/
	else {
   			throw new IllegalArgumentException("This video: " + cvn + " is unknown!");
   		}
	
	return vd;
}


/**
 * To transform the real model name into "class" model name
 * @param name
 * @return
 */
public static String createModelName(String name) {
	
	if ( name.equals("On-Off") ) {
  		return new String("OnOff");
  	}
  	else if (name.equals("M/G/Inf")) {
  		return "MGInf";
  	}
  	else if (name.equals("M/G/Inf Complex")) {
  		return "MGInfComplex";
  	}
  	else if (name.equals("MMPP-2")) {
  		return "MMPP2";
  	}
  	else if (name.equals("MMPP-N")) {
  		return "MMPPN" ;
  	}
  	else if ( name.equals("On-Off Heterogeneous Aggregated Flow")) {
  		return "OnOffHeterogeneousAggregatedFlow";
  	}
	else if (name.equals("M/G/Inf Complex Aggregated Flows")) {
			return "MGInfComplexAggregatedFlow";
	}
  	else { return name; }
}

public static String createInvModelName(String name) {
	
	if (name.equals( "OnOff" )) { return "On-Off";	}
	
  	else if (name.equals("MGInfComplex")) {
  		return "M/G/Inf Complex";
  	}
  	else if (name.equals("MGInf")) {
  		return "M/G/Inf";
  	}
  	else if (name.equals("MMPP2")) {
  		return "MMPP-2";
  	}
  	else if (name.equals("MMPPN") ) {
  		return "MMPP-N";
  	}
  	else if (name.equals("OnOffHeterogeneousAggregatedFlow") ) {
  		return "On-Off Heterogeneous Aggregated Flow";
  	}
	else if (name.equals("MGInfComplexAggregatedFlow")) {
			return "Video Aggregated Flows" ;
	}
  	else { 	return name;	}
}


/**
 *  To remove : " ",".", "/", "("...
 * @param name
 * @return
 */
public static String removeCharacters( String name, char characters) throws PatternSyntaxException, NullPointerException {
	
	String ans = "" ;
	Character defaultValue = new Character('\u0001');
	String[] tmp;
	
	while( name.matches( defaultValue.toString() ) ) {
		defaultValue = new Character( Character.forDigit( Character.digit( defaultValue.charValue(), Character.MIN_RADIX), Character.MIN_RADIX));
	}
	
	//ans = name.replace( characters, defaultValue.charValue());
	tmp = name.replace( characters, defaultValue.charValue()).split(defaultValue.toString());
		
	for (int i=0;i<tmp.length;i++) { ans += tmp[i]; }
	
	return ans;
}





public static void main(String[] args) {	
	//String name1 = new String("Bean_(Medium Quality)");
	//System.out.println(SpecificObjectCreation.removeCharacters(name1,'('));
	
	int cpt = 0;
	int[][] array = new int[3][7];
	int[] idx = { 4, 0, 2 };
	
	for (int i=0;i<array.length;i++) {
		for (int j=0;j<array[0].length;j++) {
			array[i][j] = cpt;
			cpt++;
		}
	}
	MyTableOperation.print2DArray(7,array);
	MyTableOperation.print2DArray(7, MyTableOperation.circularPermutation(idx, array));
	
}


}
