package utils.myPlotter;

import ptolemy.plot.Plot;

/**
 * PlotterProperties
 * 
 * @author mladoue
 * @version 0.1, 15/04/03
 */
public class PlotterProperties {

	public static void setPlotProperties(Plot plotName, int XPlotSize, int YPlotSize, String title, int YRangeMin, int YRangeMax, int XRangeMin, int XRangeMax, String XLabel, String YLabel) {
		 //Create the simple plot by calling methods.
		plotName.setSize(XPlotSize, YPlotSize);
		plotName.setTitle(title);
		plotName.setYRange(YRangeMin, YRangeMax);
		plotName.setXRange(XRangeMin, XRangeMax);
		plotName.setXLabel(XLabel);
		plotName.setYLabel(YLabel);
	}
	
	/**
	 * Method setBasicPlotProperties
	 * 
	 * @param plotName  the Plot that we want to customize
	 * @param XPlotSize  the X size of the plot : width
	 * @param YPlotSize  the Y size of the plot : height
	 * @param title	The title of this plot
	 * @param XLabel	the X label of this plot
	 * @param YLabel	the Y Label of this plot
	 */
	public static void setBasicPlotProperties(Plot plotName, int XPlotSize, int YPlotSize,String title, String XLabel, String YLabel) {
		plotName.setSize(XPlotSize, YPlotSize);
		plotName.setTitle(title);
		plotName.setXLabel(XLabel);
		plotName.setYLabel(YLabel);
	}
	
	
	/**
	 * Method setSpecificPlotProperties
	 * @param plotName  the Plot that we want customize
	 * @param impulses if true, then a line will be drawn from any plotted point down to the x axis 
	 * @param button if true, it add 4 buttons to resize....
	 * @param marksStyle  possibilities could be "none", "points", "dots", or "various"
	 */
	public static void setSpecificPlotProperties( Plot plotName, boolean impulses, boolean button,String marksStyle) {
		plotName.setImpulses(impulses);
		plotName.setButtons(button);
		plotName.setMarksStyle(marksStyle); 
	}
	
	public static void setYTick(Plot plotName, double value) {
		plotName.addYTick("0",0);
		plotName.addYTick( new String("" + value/4 ), (value/4) );
		plotName.addYTick( new String("" + value/2 ), (value/2) );
		plotName.addYTick( new String("" + 3*value/2 ), (3*value/2) );
		plotName.addYTick( new String("" + value), value);
	}
	
	public static void setXTick(Plot plotName, double value) {
		plotName.addYTick("0",0);
		plotName.addYTick( new String("" + value/2 ), value/2 );
		plotName.addYTick( new String("" + value), value);
	}
}
